#################################################################################
#
#  Licensed Materials - Property of IBM
#  Restricted Material of IBM
#  IBM Rational Test RealTime
#  (c) Copyright IBM Corp. 2007-2014 All Rights Reserved.
#
#  US Governement Users Restricted Rights - Use, duplication or
#  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
#################################################################################

##########################################################################
#                                                                        # #
# Rational Test RealTime                                                 #   #
#                                                                        #######
#                 -*- command line Testing -*-                                 #
#                                                                              #
#                                                                              #
# Required global variables:
#   $NAME='PhoneNumber'; #used as node name
#   $XRDFILE='cvisual6\\PhoneNumber.xrd';
#   $TESTPROGRAM='.\\cvisual6\\PhoneNumber.exe';
#   $TESTPROGRAM_ABS='C:\\......\\cvisual6\\PhoneNumber.exe';
#   @OTCFILES = otc file names for C++
#   $OTDNAME = otd file name for C++
#   $UNITTESTING_TESTSCRIPTNAME = ptu file name for C
#   $ATU_INTERMEDIATE_FILE = generated source file name for  C
#   @INTEGRATEDFILENAMES
################################################################################

# To do output in chronological order when stderr and stdout are both used
use FileHandle;
use File::Spec;
STDOUT->autoflush(1);
STDERR->autoflush(1);

BEGIN {
## globals ############
$TestRTCC=1;
#######################
$SCRIPTDIR="$ENV{'TESTRTDIR'}/lib/scripts/";
$TARGETDIR=$ENV{ATLTGT};
$LP_TARGETDIR=$ENV{'ATLTGT'};
$INTDIR=$TARGETDIR;$INTDIR=~s,.*[\\\/](\w+)[\\\/]?$,$1,;
$OUTDIR=$INTDIR;
$CONFIGURATION=$INTDIR;
$INIFILE='tp.ini';
$LOGFILENAME='TestRT.log';
$STAGE='cptler';
  $ATTMODE=0;
  $ATCMODE=0;
  $ATPMODE=0;
  $ATQMODE=0;
  $ATSMODE=0;
  $ATUMODE=0;
  $ATOMODE=0;
  $ATKMODE=0;
  $ATJMODE=0;
  $ATAMODE=0;
  $ATZMODE=0;
  $ATGMODE=0;
  $DCPMODE=0;
  $MNTMODE=0;
$CODE_INSERTION=1;
$ATO_PREPRO_MAX_ERRORS=30;
$PROJECT_NAME='';
$PROJECT_PATH='none';
$WORKSPACE_NAME='';
$CONTONWARN=1;
$UNITTESTING_TESTSCRIPTNAME='';
$OTDNAME='';
}
require $SCRIPTDIR . "BatchCCDefaults.pl";
require $SCRIPTDIR . "Fcts.pl"; # for Unknown_ATLTGT
if(@ARGV) {
	if($ARGV[0]=~m/-help/i) {
		help();
		exit(0);
	}elsif($ARGV[0]=~m/-TDP=(.+)$/i){
		$TARGETDIR=$1;
		$TARGETDIR=~s,\",,g;
		if($TARGETDIR=~m/\\\//){
			$INTDIR=$TARGETDIR;$INTDIR=~s,.*[\\\/](\w+)[\\\/]?$,$1,;
		} else {
			$INTDIR=$TARGETDIR;
			$TARGETDIR=getAppData().'/targets/'.$INTDIR;
			$TARGETDIR=$ENV{TESTRTDIR}.'/targets/'.$INTDIR unless(-e $TARGETDIR."/tp.ini");
		}
		$ENV{ATLTGT}=$TARGETDIR;
		$LP_TARGETDIR=$TARGETDIR;
		$OUTDIR=$INTDIR;
		$CONFIGURATION=$INTDIR;
		print "ATLTGT=$TARGETDIR\n";
		shift;#remove this option from argv
	}
	elsif ($ARGV[0]=~m/-config(=)?(.+)?$/) {
		shift;#remove this option from argv
		if($1 ne ''){
		    $envnode=$2;
		} else {
		    $envnode=shift(@ARGV);;
		}
		$envnode=~s,\",,g;
		die "unable to open $envnode\n" unless (-f $envnode);
		require $envnode ;
		unless($ENV{'TESTRTDIR'}) {
			my $d=$ATTOLHOME;
			$d=~s,[\\\/]$,,;
			$ENV{'TESTRTDIR'}=$d;
		}
		$ENV{'ATLTGT'}=$TARGETDIR;
		unshift(@ARGV,"-optinscript");#default mode in eclipse
	}
} else {
	help();
	exit(0);
}

$INIFILE='ada95.ini' if(-e "$TARGETDIR/ada95.ini");
  # some options are not available in this mode
$ATT_ON_THE_FLY=0;
$ATU_RENAME_FUNC=1;
#set minimum required
$XTPFILE = "TestRTccfiles.xtp" unless($XTPFILE);

require $SCRIPTDIR . "TestScript.pl";
require $SCRIPTDIR . "Source.pl";
require $SCRIPTDIR . "ObjecTest.pl";
require $SCRIPTDIR . "UnitTesting.pl";
require $SCRIPTDIR . "Application.pl";
require $SCRIPTDIR . "StartObjecTest.pl";
require $SCRIPTDIR . "StartUnitTesting.pl";
require $SCRIPTDIR . "UpdateUnitTestingScript.pl";
require $SCRIPTDIR . "metricC.pl";


# some settings are modified by the called scripts
my $savATAMODE;
my $savATZMODE;
my $savATGMODE;
my $savDCPMODE;
my $savATTMODE;
my $savATCMODE;
my $savATPMODE;
my $savATQMODE;
my $savATSMODE;
my $savATUMODE;
my $savATOMODE;
my $savATKMODE;
my $savATJMODE;
my @savCOMPLETE_INCLUDE_DIR_LIST;

sub setSettings
{
  $ATAMODE=$savATAMODE;
  $ATZMODE=$savATZMODE;
  $ATGMODE=$savATGMODE;
  $DCPMODE=$savDCPMODE;
  $ATTMODE=$savATTMODE;
  $ATCMODE=$savATCMODE;
  $ATPMODE=$savATPMODE;
  $ATQMODE=$savATQMODE;
  $ATSMODE=$savATSMODE;
  $ATUMODE=$savATUMODE;
  $ATOMODE=$savATOMODE;
  $ATKMODE=$savATKMODE;
  $ATJMODE=$savATJMODE;
  @COMPLETE_INCLUDE_DIR_LIST=@savCOMPLETE_INCLUDE_DIR_LIST;
  $CODE_INSERTION=1;

}

sub help
{
my ($dirlauncher,$launcherBase,$extl)=SplitFileName($0);
    print STDERR "#?$SMALL_PRODUCT_NAME-I-".uc($launcherBase).", Usage:  $launcherBase <launcher options> <instrum options> --<settings> <testScriptFile> <source files> -I<include directory> -D<macro> [-- <cflags>] [-CPPFLAGS- <CPPFLAGS>] [-PPFLAGS- <PPFLAGS>] [-LDFLAGS- <ldflags>]\nOptions and setting are listed in Help bellow.\n";
    open HP, "<$ENV{TESTRTDIR}/lib/locale/AttolccPlHelp.txt" || die &PerlTranslate("TestRT_test.pl", "Cannot open the file %1\n", "%1 is the file name", $ENV{TESTRTDIR}/lib/locale/AttolccPlHelp.txt);
    while (<HP>) {print;} close(HP);
}

###########################################################################
# read the launcher options
sub read_options
{
my $onCompilerOptions=0;
my $optionsInTest=0;
   while(@ARGV)
   {
	$_=shift(@ARGV);
	s,^\"(.+)\"$,$1,;
	#print "<$_>\n";
	my $lcarg=lc($_);
	if(/^--$/ || /^-CFLAGS-$/){#separator cmd CFLAGS for prepro and compil
			$onCompilerOptions=1;
	} elsif(/^-CPPFLAGS-$/){#separator cmd CPPFLAGS for prepro and compil
			$onCompilerOptions=2;
	} elsif(/^-PPFLAGS-$/){#separator cmd PPFLAGS for prepro only
			$onCompilerOptions=3;
	} elsif(/^-LDFLAGS-$/){#separator cmd LDFLAGS for prepro only
			$onCompilerOptions=4;
	} elsif($onCompilerOptions){
	    if($onCompilerOptions==1){
		$CFLAGS.=' '.$_;
	    } elsif($onCompilerOptions==2){
		$CPPFLAGS.=' '.$_;
	    } elsif($onCompilerOptions==3){
		$PPFLAGS.=' '.$_;
	    } elsif($onCompilerOptions==4){
		$LDFLAGS.=' '.$_;
	    }
	} elsif(/^--([a-zA-Z_0-9]+)(\+?)=(\"?)(.+)\3$/){ #settings option
		my $set=uc($1);
		my $append="$2" if($2);
		my $cotStr=$3 if($3);
		my $val=$4;
		eval "\$$set=\"\Q$val\E\"";
	}
	elsif(/^--([a-zA-Z_0-9]+)$/){ #settings option
		my $set=uc($1);
		eval "\$$set=1";
	}
	elsif($lcarg eq "-optinscriptrel")	{$optionsInTest=2; readOptionsInTestDriver($UNITTESTING_TESTSCRIPTNAME.$OTDNAME,$optionsInTest);}
	elsif($lcarg eq "-optinscript")		{$optionsInTest=1; readOptionsInTestDriver($UNITTESTING_TESTSCRIPTNAME.$OTDNAME,$optionsInTest);}
	elsif($lcarg eq "-verbose")		{$ENV{'ATTOLSTUDIO_VERBOSE'}=1;}
	elsif($lcarg eq "-v")			{$ENV{'ATTOLSTUDIO_VERBOSE'}=1;}
	elsif($lcarg eq "-keep")		{$KEEP=1;}
	elsif($lcarg eq "-one_level_metrics")	{$ATMMODE=1;$MET_ONE_LEVEL=1;}
	elsif($lcarg eq "-metrics_in_source")	{$ATMMODE=1;$MET_IN_SOURCE_DIR=1;}
	elsif(/^-restrict_dir_metrics=(.+)$/i)	{$ATMMODE=1;push(@MET_RESTRICT_DIR,split(/,/,$1));}
	elsif(/^-metric=(\"?)(.+)\1$/i)		{$ATMMODE=1;$metdir=$2;}
	elsif(/^-ada(\d\d)$/i)			{$INIFILE="ada$1.ini";}
	elsif(/^-ada(LIEN|LINK)=(\"?)(.+)\2$/i)	{$USER_ALK_FILE=$3;}
	elsif(/^-codereview=(\"?)(.+)\1$/i)	{$MISRA_MODE=1;$MISRA_CONF=$2;}
	elsif(/^-codereview$/i)			{$MISRA_MODE=1;$MISRA_CONF="$ENV{'TESTRTDIR'}/plugins/Common/lib/confrule.xml";}
	elsif(/^-\#.*$/)		   	{$showCmd=1;$ATTOLCC_VERBOSE=1;}
	elsif(/^-I(.+)$/)			{push(@INCLUDE_DIR_LIST,split(/,/,$1));}
	elsif(/^-D(.+)$/)			{push(@GENERATION_CONDITION,$1);}
	elsif(/^-env_(.+)=(.+)$/i)		{$ENV{uc($1)}=$2;}
	elsif(/^-(compare|ra|va)(=.+)?$/i)	{$ATU_REPORT_OPTIONS.=$_.' ';$ATU_STRATEGY=10 if($1=~m/^VA/i);}
	elsif(/^-(NO)?(SIMULATION)/i)		{$ATU_SIMULATION=1 if($1 eq '');}
	elsif(/^-(EX|NO)?(SERVICE|FAMILY|TEST|RESTRICTION|EXPAND|COMPRESS)=/i) {$PREPRO_CMDLINE_OPT.=$_.' ';}
	elsif(/^-opt=(\"?)(.+)\1$|\@(\"?)(.+)\3$/i){ #" accept @optFile or -opt=optFile for options
		my $fileOpt=$2.$4;
		# read the options in the file and push into the existing @argv to be analysed as other
		open OPTIN,"<$fileOpt" || die &PerlTranslate("TestRT_test.pl", "Cannot open the file %1\n", "%1 is the file name", $fileOpt);
		while (<OPTIN>){
			chomp($_);
			#print("[$_]\n");
			my @optInFile=splitArgs($_);
			push(@ARGV,@optInFile);
		}
		close OPTIN;
	}
	elsif (/^-stage=(.+)$/i){
		$STAGE=$1;
	}
	elsif(/^-/) {
		{
		  $INSTRUM_CMDLINE_OPT.=$_.' ';
		  $_=uc($_);
		  #debug("instr option:$_");
		  $ATKMODE=1 if (/^-AU/); #AUTO_OTI
		  $ATAMODE=1 if (/^-APP/);#application profiling (common stack instrum)
		  $ATGMODE=1 if (/^-CCO/);#Ctrl Coupling
		  $DCPMODE=1 if (/^-DCP/);#Data Coupling
		  $ATPMODE=1 if (/^-MEM/);
		  $ATQMODE=1 if (/^-PERF/);
		  $ATMMODE=1 if (/^-MET/);
		  $ATL_CLOCK_KIND=1 if(/^-PERF.*=P/);
		  $ATTMODE=1 if (/^-TR/);#TRACE
		  if(/^-COMPA/){$ATC_INFORMATION=1;$ATCMODE=1;}#1compact 2count
		  if(/^-COUN/){$ATC_INFORMATION=2;$ATCMODE=1;} #1compact 2count
		  $ATCMODE=1 if ((/^-PAS/) || (/^-PRO/) || (/^-BL/) || (/^-COND/));
		  if (/^-STAC/) {$ATAMODE=1;$ATZMODE=1;}#Stack_size
		  if (/^-MONI/) {$ATAMODE=1;$MNTMODE=1;}#monitor
		}
	}
  	elsif(-f $_) {
		   if(/\.otc$/) {push(@OTCFILES,$_);$ATKMODE=1;}
		elsif(/\.otd$/) {$OTDNAME=$_;$ATOMODE=1;$INIFILE='tpcpp.ini';my ($d,$b,$e)=SplitFileName($_);$NAME=$b;$TDFFILE=$OUTDIR."/$b.tdf";readOptionsInTestDriver($OTDNAME,$optionsInTest) if($optionsInTest); }
		elsif(/\.ptu$/) {$UNITTESTING_TESTSCRIPTNAME=$_;$ATUMODE=1;  my ($d,$b,$e)=SplitFileName($_);$NAME=$b;readOptionsInTestDriver($UNITTESTING_TESTSCRIPTNAME,$optionsInTest) if($optionsInTest);}
		else {
			push(@INTEGRATEDFILENAMES,$_);
			unless($NAME) {my ($d,$b,$e)=SplitFileName($_);$NAME=$b;}
		}
	}
	elsif(/\*/) {
		my @files = glob $_;
		push(@ARGV,@files );
	}
	else {print PerlTranslate("TestRT_test.pl","unknown file: $_\n use -help option to get usage\n");}
   }
EnterInScript();
$TDP_LANGUAGE =$Ini{'LANGUAGE'};
$SRCEXT=$Ini{'SRCEXT'};
$OBJEXT=$Ini{'OBJEXT'};
$LIBEXT=$Ini{'LIBEXT'};
$DLLEXT=$Ini{'DLLEXT'};

$PROJECT_PATH=GetCurrentDir();
$XRDFILE=$OUTDIR.'/'.$NAME.'.xrd';
#$XRDFILE=$PROJECT_PATH.'/'.$OUTDIR.'/'.$NAME.'.xrd';
$WORKSPACE_PATH=$PROJECT_PATH;
$WORKING_DIR=$PROJECT_PATH;
$TESTPROGRAM=$INTDIR.$PATH_SEPARATOR.$NAME;$TESTPROGRAM.='.'.$Ini{EXEEXT} if($Ini{EXEEXT});
$TESTPROGRAM_ABS=$PROJECT_PATH.$PATH_SEPARATOR.$TESTPROGRAM;
}

sub reports
{
  my $log=shift;
  my $xtp=shift;
  my $tsf;
  my @files;
	open LOG, "<$log";
	while(<LOG>)
	{
		chomp;
		if (/^(TIO|TPF|TQF|TDF|TSF|FDC|MET|CRC|XRD|RTX|REQ|TZX|TGX|DCX) (.+)$/){
		  my $f=$2;
		  my $c=$1;
		  my @l=grep(/^\Q$f\E$/, @files);
		  push (@files, $f) unless(scalar(@l));
		  if($c eq 'FDC') {$tsf=1;push(@FDCFILES,$f);}
		  if($c eq 'TSF') {$tsf=1;}
		}elsif (/^OTS (.+)$/){
		  push(@OTSFILES,$1);
		  push(@dummy,$1);
		}elsif (/^OBJ (.+)$/){
		  push(@OBJECTS,$1);
		}elsif (/^XOB (.+)$/){
		  push(@XOB,$1);
		  push(@dummy,$1);
		}elsif (/^(DUM|ALK) (.+)$/){
		  push(@dummy,$2);
		}# other lines are ignored
	}
	close(LOG);
	if($xtp) {
		my ($base,$n,$e)=SplitFileName($xtp);
		$base=~s/[\\\/]$//g;
		my $ch;
		my $pwd=GetCurrentDir();
		$ch=1 if($base && ($base ne $pwd));
		$base=$pwd unless($base);

		#print "writing XTP file $xtp, $pwd, $ch, $base\n";
		open XTP, ">$xtp";
		foreach $f (@files) {
		    if($f =~ /^(\w:)?[\\\/]/) {
			$f = File::Spec->abs2rel( $f, $base ) ;
		    } elsif($ch) {
			$f = File::Spec->rel2abs( $f , $pwd ) ;
			$f = File::Spec->abs2rel( $f, $base ) ;
		    }
		    print XTP "$f\n" ;
		}
		close XTP;
		unless($KEEP){
		  	unlink(@dummy); #remove only at the build end
		  	print "remove ",join("\n       ",@dummy),"\n"; #remove only at the build end
		}
	}
}

sub buildOt
{
	my $otFile=shift;
	$FILENAME=$otFile;
	my ($fdir,$otname,$otext)=SplitFileName($FILENAME);

	$SRCFILE=$otname.'.'.$otext.'.cpp';
	$OTIFILE=$INTDIR.$PATH_SEPARATOR.$otname.'.'.$otext.'.oti';

	exit(1) if(TestScript());
}

$BINDIR=GetBinDir() unless($BINDIR);
$BINDIR =  ShortPathName($BINDIR);
$BINPATH=$BINDIR.$PATH_SEPARATOR;
$BINPATH='' if($BINDIR=~/\s/);
read_options() ;
$TARGETDIR=ShortPathName($TARGETDIR);

CheckIntDir();
CheckOutDir();

# some settings are modified by the called scripts
$savATAMODE=$ATAMODE;
$savATZMODE=$ATZMODE;
$savATGMODE=$ATGMODE;
$savDCPMODE=$DCPMODE;
$savATTMODE=$ATTMODE;
$savATCMODE=$ATCMODE;
$savATPMODE=$ATPMODE;
$savATQMODE=$ATQMODE;
$savATSMODE=$ATSMODE;
$savATUMODE=$ATUMODE;
$savATOMODE=$ATOMODE;
$savATKMODE=$ATKMODE;
$savATJMODE=$ATJMODE;

@savCOMPLETE_INCLUDE_DIR_LIST=();
foreach my $i (@COMPLETE_INCLUDE_DIR_LIST){
	$i=$WORKSPACE_PATH.$i if(($i =~ /^[\\\/]/) && (!(-d $i))) ;
	push(@savCOMPLETE_INCLUDE_DIR_LIST,$i);
}
@COMPLETE_INCLUDE_DIR_LIST=@savCOMPLETE_INCLUDE_DIR_LIST;
@OTIFILES=();

if($ENV{ATTOLSTUDIO_VERBOSE}) {
print "$0\n";
print "envNode: ",$envnode,"\n" if($ECLIPSE_IDE);
print "Current dir: ", GetCurrentDir() ,"\n";
print "Include Paths:",join(',',@COMPLETE_INCLUDE_DIR_LIST),"\n";
}
if ($STAGE =~ /w/ ) #wizard (start)
{
	ClearLogFile($LOGFILENAME2);
	if($TDP_LANGUAGE eq 'CPP'){
		exit(1) if(StartObjecTest());
	}else{
		unless($TESTEDFILE){
			$TESTEDFILE=shift(@INTEGRATEDFILENAMES);
		}
		@INTEGRATEDFILES=@INTEGRATEDFILENAMES;
		$SCRIPTFILE=$UNITTESTING_TESTSCRIPTNAME unless($SCRIPTFILE);
		exit(1) if(StartUnitTesting());
	}
	print PerlTranslate("TestRT_test.pl",  "\nCreation done.\n");
	exit(0);

}elsif ($STAGE =~ /u/ ) #update
{
	if($TDP_LANGUAGE eq 'CPP'){
		print PerlTranslate("TestRT_test.pl", "TestRT-W-NOFEATURE This feature is not available for C++: no update possible\n");
	}else{
		$FILENAME=$UNITTESTING_TESTSCRIPTNAME;
		exit(1) if(UpdateUnitTestingScript());
	}
	print PerlTranslate("TestRT_test.pl",  "\nUpdate done.\n");
	exit(0);

}elsif ($STAGE =~ /m/ ) #metrics
{
	my $status=0;
	ClearLogFile($LOGFILENAME2);
	foreach $FILENAME (@INTEGRATEDFILENAMES){
		$status|=metricsC ($TDP_LANGUAGE, $FILENAME, $LOGFILENAME2, $METDIR);
	}
	print PerlTranslate("TestRT_test.pl",  "\nMetrics done.\n");
	exit($status);

}else{ #build
	# if STAGE is not complete that means we are running a part of the build. So log file must not be cleared
	ClearLogFile($LOGFILENAME)  if($STAGE eq 'cptler');
	my $x;
#	print "Source compilations\n";
	foreach $FILENAME (@DATAPOOLFILENAMES){

		exit(1) if(Source());
	}

#		print "OTC generation:\n";
	foreach (@OTCFILES){
		buildOt($_) ;
	}

	if($OTDNAME){
#		print "OTD generation:\n";
		buildOt($OTDNAME) ;

	}elsif($UNITTESTING_TESTSCRIPTNAME){
#		print "PTU generation:\n";
		$FILENAME=$UNITTESTING_TESTSCRIPTNAME;

		$ATU_INTERMEDIATE_FILE='T'.$NAME unless($ATU_INTERMEDIATE_FILE);
		TDPAdaGenerate ( $TDP_LANGUAGE ) if ($TDP_LANGUAGE=~/^ADA/ );
		exit(1) if(TestScript());
	}else{print PerlTranslate("TestRT_test.pl", "TestRT-W-NOTSTDRIV No Test driver selected\n") unless($VisualTest);
	}

#	print "Source compilations\n";
	$x=0;
	foreach $FILENAME (@INTEGRATEDFILENAMES){
		setSettings();
#		$CODE_INSERTION=0 if($INTEGRATEDFILENAMES_INSTR[$x] eq '0');#let 1 if not initialized
		exit(1) if(Source());
	}
#	foreach $FILENAME (@ADDITONALFILES){
#		$CODE_INSERTION=0;
#		exit(1) if(Source());
#	}
#	if($VisualTest){
#	    foreach $FILENAME (@SOURCES){
#		setSettings();
#		#$CODE_INSERTION=0 if($SOURCES_INSTR[$x] eq '0');#let 1 if not initialized
#		exit(1) if(Source());
#	    }
#	}
	setSettings();
#	print "link then exec then report genration\n";
	reports($LOGFILENAME,''); #load generated file names
	push( @OBJECTS, @LINKEDFILES);
	if($OTDNAME){
		exit(ObjectTest());
	}elsif($UNITTESTING_TESTSCRIPTNAME){
		exit(UnitTesting());
	}else {
		exit(Application());
	}

	#print "preparation to view reports\";
	reports($LOGFILENAME,$XTPFILE);
	#unlink($LOGFILENAME);
	print PerlTranslate("TestRT_test.pl",  "\nReports done.\n");
	print PerlTranslate("TestRT_test.pl",  "type studioreport or double-click on .xtp file to see the report.\n") if($envnode eq '');
	exit(0);
}

sub readOptionsInTestDriver
{
my $tstFile=shift;
my $pathType=shift; #1 from exec dir, 2 from script dir
my $cl='';
return unless($tstFile);
    my ($tstDir,$tstBase,$tstExt)=SplitFileName($tstFile);
    $ENV{TSTSCRIPT_LOC}=absolutePath($tstDir);
    $ENV{PROJECT_LOC}=$PROJECT_PATH if($PROJECT_PATH ne '' && $ENV{PROJECT_LOC} eq '');
    $ENV{WORKSPACE_LOC}=$WORKSPACE_PATH if($WORKSPACE_PATH ne '' && $ENV{WORKSPACE_LOC} eq '');
    if(open(IN,$tstFile)){
	while(<IN>){
		last if(/^\s*(HEADER|INCLUDE|TEST|import|def)\W/);
		if(s/^(--|\/\/|#--)\%([fo])\s//){
		    $cl="-" if($1 eq 'f');
		    #possible notations:${workspace_loc:/RichardRTP/src/sub.c} $workspace_loc:/RichardRTP/src/sub.c $(workspace_loc)/RichardRTP/src/sub.c
		    chomp($_);
		    my @locArgs=splitArgs($_);
		    foreach(@locArgs){
			    s/\$\{/\"\$/ if(s/\}$/\"/);
			    s/\$[\(\{]?(\w+)[\)\}]?\:?/$ENV{uc($1)}/g;
			    #relative path must be from script location
			    if($pathType==2 && $tstDir){
				if(/^(-[I])?([^-].+)$/){
				   my $opt=$1;
				   my $path=$2;				   
				   $_=$opt.$tstDir.$path if($path!~m(/^(\w\:)?[\\\/]/) && -e $tstDir.$path);
				}
			    }
		    }
		    unshift(@ARGV,@locArgs);
		} elsif (s/^(--|\/\/)\%[c]\sattolstart\s//){
			my $cl=$_ unless($cl ne '');
		}
	}
	close IN;
	if($cl ne '-')
	{
		#"C:\.....\src\File1.c" "C:\.....\File12.ptu" /INSERT /INTEGRATE="C:\.....\src\File2.c,C:\...\src\File3.c" /INCL="src" /STD_DEFINE="C:\I....\ana\atus_c.def" /RESTRICTION="ANSI"
		if($cl=~m/^\s*\"([^\"]\.c)\"/){unshift(@ARGV,$1)unless($cl=~m/\s[-\/]INSERT\b/i);} #push the source file under test
		if($cl=~m/[-\/]INTEGRATE=\"([^\"])\"/i){unshift(@ARGV,split(/,/,$1));} #push integrated files
	}
    } else {
	print "Unable to open test script $tstFile\n";
    }
}
1;
