#!perl -w
#################################################################################
#
#  Licensed Materials - Property of IBM
#  Restricted Material of IBM
#  IBM Rational Test RealTime
#  (c) Copyright IBM Corp. 2003-2016 All Rights Reserved.
#  (c) Copyright HCL Technologies Ltd. 2017-2018.  All Rights Reserved.
#
#  US Governement Users Restricted Rights - Use, duplication or
#  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
#################################################################################

##########################################################################
#                                                                        # #
# Rational Test RealTime                                                 #   #
#                                                                        #######
#                      -*-  Source Instrumentation launcher -*-                #
#                                                                              #
#                                                                              #
################################################################################

push(@INC,$SCRIPTDIR);

################################################################################
# useful for stdout/stderr direct viewing inside 'console' of studio window
# (better: we have stdout/stderr lines in right order and not stder before stdout
use FileHandle ;
use File::Path;
STDOUT->autoflush(1);
STDERR->autoflush(1);

require "attolcclibh.pl";
require "Products.pl";
require "codeChecker.pl";
require "metricC.pl";
require "readLogFile.pl";

my $pwd = GetCurrentDir();
$INTDIR = "." if ($INTDIR eq '');

my $StdErrFile="Err.log"; #files used by SystemL func
my $StdOutFile="Out.log";

# Default settings
# Launcher flags (declared before require $envfile
$INIFILE="tp.ini" unless($INIFILE);
$TDP_LANGUAGE="C" unless($TDP_LANGUAGE);
my $lang;
#at first attolcc exec tdp have to be generated
my $generateTdp=1;
my $link=1;
our $Link=0;
our $ADDFLAGS="";
our @COMPLETE_INCLUDE_DIR_LIST=();
our @GENERATION_CONDITION=();
our @INCLUDED_FILES=();
@XOB=();
@MET=();
@TSFFILES=();
@FDCFILES=();
$MET_ONE_LEVEL=0;
$MET_IN_SOURCE_DIR=0;
$PID='';
$launcher=launcherName() unless($launcher);
#my ($dir,$launcher,$extl)=SplitFileName($0);
$TreatmentOnSource=0;
$TreatmentOnPreprocessed=0;
$TreatmentOnInstrumented=0;
$TreatmentOnObject=0;
$TreatmentBeforeLink=0;

#ReadProductName();
setMachineVars();

#default values
$IncludeFlag="-I"; # must be defined in attolcc.pl
$DefineFlag="-D"; # as well

my $activ=1;
my $firstExec=0;
my $iniHasChanged=0;
my  @otc=();
#--------------- begin of saved variable --------------
 $ATTOLCC_LOGNAME=$launcher."Log.log" unless($ATTOLCC_LOGNAME); # default log file name for error&trace&exec
 $ATTOLCC_LOGFILE=0 unless($ATTOLCC_LOGFILE);
 $ATTOLCC_NOLIST=0 unless($ATTOLCC_NOLIST);
 $ATTOLCC_VERBOSE=0 unless($ATTOLCC_VERBOSE);
 $KEEP=0 unless($KEEP);
 $NOSTOP=0 unless($NOSTOP);
 $IGNORE="" unless ($IGNORE);
 $INSTRUM="" unless ($INSTRUM);
 $LOGFILENAME="" unless ($LOGFILENAME);
 $instrumOpt="" unless($instrumOpt);
 $attolcc_tmpdir="";
 $launcherEnvOptions="";
 $force_tdp_cc=0;
 $showCmd=0;
 $no_tdp=0;
 $force_lang=0;
 $force_tdp_lang=0;
 $metdir="";
 @oti=();
#--------------- end of saved variable --------------

$sp=" ";
$cot="\"";
my $pc_cmdDiff=0; #1 means that some options are used for prepro and not used for compil
#my @Errors;
my @filesToRemove=();
my @srcFilesToInstrum=();

my $OutFile;

my @launcherOptions=();
my $launcherStrOptions="";
my $onCompiler=0;
my @IgnoreList=();
my @InstrumList=();
my $Pext=".i"; # preprocessed file ext
my $Iext="_aug"; # Instrumented file sufix
%settings=(); #memo for save

#between compilation some data are saved into env_attolcc.pl it is removed after the successful link
$envfile="env_$launcher.pl";
###########################################################################
# read the launcher options
sub read_Launch_cmd #(@)
{
   my @argv=@_;
   #debug("analyse cmd");
   $ATKMODE=0;
   $ATPMODE=0;
   $ATAMODE=0;
   $ATGMODE=0;
   $DCPMODE=0;
   $ATZMODE=0;
   $ATQMODE=0;
   $ATL_CLOCK_KIND=0;
   $ATTMODE=0;
   $ATC_INFORMATION=0;
   $ATCMODE=0;
   $iniHasChanged=1;
   $ATTOLCC_LOGNAME=$launcher."Log.log"; # default log file name for error&trace&exec
   $force_tdp_cc=0;
   $ATTOLCC_VERBOSE=0;
   $showCmd=0;
   $KEEP=0;
   $NOSTOP=0;
   $ATTOLCC_LOGFILE=0;
   $IGNORE="";
   $force_lang=0;
   $force_tdp_lang=0;
   $instrumOpt="";
   $MET_ONE_LEVEL=0;
   $MET_IN_SOURCE_DIR=0;
   $ATMMODE=0;
   @MET_RESTRICT_DIR=();
   $metdir='';
   $MISRA_MODE=0;
   while(@argv)
   {
	$_=shift(@argv);
	my $lcarg=lc($_);
	if(/^--([a-zA-Z_0-9]+)(\+?)=(\"?)(.+)\3$/){ #settings option
		my $set=uc($1);
		my $append="$2" if($2);
		my $cotStr=$3 if($3);
		my $val=$4;
		if($^O=~/win32/i){
			if($set =~/FILE/) {
			          $val =~ s/\\/\\\\/g;
#			          $val = LocaleStringReplace($val,"\\\\","\\\\"); # for japanese
			}
		} else {
		#pb for CFLAGS	if(($val =~/ /) && !($set =~/NAME|FILE/)) {$val = $cot.$val.$cot;}
		}
		#debug("settings:$set $append=($cotStr) $val");
		if(($append) && (($set eq 'CFLAGS') || ($set eq 'CPPFLAGS'))){
			if (!($ADDFLAGS=~ /$val/)) {
				$ADDFLAGS.=' '.$val;
				$settings{'ADDFLAGS'}=$ADDFLAGS;
			}
			next;
		}
		$settings{$set}=$val;
		eval "\$$set='$val'";
	}
	elsif(/^--([a-zA-Z_0-9]+)$/){ #settings option
		my $set=uc($1);
		$settings{$set}=1;
		eval "\$$set=1";
	}
	# launcher or instrum option
	elsif($lcarg eq "-nostop")	{$NOSTOP=1;}
	elsif($lcarg eq "-keep") 	{$KEEP=1;}
	elsif($lcarg eq "-force_tdp_cc"){$force_tdp_cc=1;}
	elsif($lcarg eq "-force_c_tdp")	{$force_tdp_lang=1;$TDP_LANGUAGE="C";}
	elsif($lcarg eq "-force_cpp_tdp"){$force_tdp_lang=2;$TDP_LANGUAGE="CPP";}
	elsif($lcarg eq "-force_c")	{force_language(1);}
	elsif($lcarg eq "-force_cpp")	{force_language(2);}
	elsif($lcarg eq "-memprolib")   {$ATL_MEM_LIB=1; $settings{ATL_MEM_LIB}=1; $instrumOpt.= ' -mempro';}
	elsif($lcarg eq "-nolist")   	{$ATTOLCC_NOLIST=1;}
	elsif($lcarg eq "-linksection")	{$LINKSECTION=1;}
	elsif($lcarg eq "-log")   	{$ATTOLCC_LOGFILE=1;}
	elsif($lcarg eq "-verbose")	{$ATTOLCC_VERBOSE=2;$ENV{ATTOLSTUDIO_VERBOSE}=1;}
	elsif($lcarg eq "-v")		{$ATTOLCC_VERBOSE=1;}
	elsif($lcarg eq "-one_level_metrics")	{$ATMMODE=1;$MET_ONE_LEVEL=1;}
	elsif($lcarg eq "-metrics_in_source")	{$ATMMODE=1;$MET_IN_SOURCE_DIR=1;}
	elsif(/^-restrict_dir_metrics=(.+)$/i)	{$ATMMODE=1;push(@MET_RESTRICT_DIR,split(/,/,$1));}
	elsif(/^-metric=(\"?)(.+)\1$/i)		{$ATMMODE=1;$metdir=$2;}
	elsif(/^-metric/i)			{$ATMMODE=1;}
	elsif(/^-monitor(ing)?io=(.+)$/i) {$ATAMODE=1;$MNTMODE=1;$MNT_IO=uc($2);$MNT_IO='RTRT_'.$MNT_IO if($MNT_IO!~m/(RTRT_|\d)/);}
	elsif(/^-codereview=(\"?)(.+)\1$/i)	{$MISRA_MODE=1;$MISRA_CONF=$2;}
	elsif(/^-codereview$/i)			{$MISRA_MODE=1;$MISRA_CONF=$ENV{'TESTRTDIR'}.$MISRA_DEFAULT_C_CONF;}
	elsif(/-\#.*$/)		   	{$showCmd=1;$ENV{'ATTOLSTUDIO_VERBOSE'}=1;}
	elsif(/^-log=(\"?)(.+)\1$/i)   	{$ATTOLCC_LOGNAME=$2;$ATTOLCC_LOGFILE=1;}
	elsif(/^-ignore=(\"?)(.+)\1$/i) {
		   #ignore list: files are separated by ',' if a file has .lst ext. the file may contains one or more file list
		   #those file lists may be on one line (using ',' as separator and/or on multiple line
		   #those file lists may involve .lst files which will be read as well as file lists.
		   my @Ignore=split(/,/,$2);
		   my $f;
		   foreach (@Ignore)
		   {
			my $fl=$_;
			$fl=~ s/\\/\//g;
			if(!(grep(/^\Q$fl\E$/,@IgnoreList))) {
			   push(@IgnoreList,$fl);
			   if(/\.lst$/) { pushFromFile($fl,@IgnoreList);}
			}
		   }
	     }
	elsif(/^-instrum=(\"?)(.+)\1$/i) {
		   #instrum list: files are separated by ',' if a file has .lst ext. the file may contains one or more file list
		   #those file lists may be on one line (using ',' as separator and/or on multiple line
		   #those file lists may involve .lst files which will be read as well as file lists.
		   my @Instrum=split(/,/,$2);
		   my $f;
		   foreach (@Instrum)
		   {
			my $fl=$_;
			$fl=~ s/\\/\//g;
			if(!(grep(/^\Q$fl\E$/,@InstrumList))) {
			   push(@InstrumList,$fl);
			   if(/\.lst$/) { pushFromFile($fl,@InstrumList);}
			}
		   }
	     }
        elsif(/^-CUSTOMINC=(.+)$/i)     {
                $ATL_CUST_INC=$1;
                open CSTI, ">customIncl.h" || die "Attolcc: Cannot write customIncl.h\n\n";
                print CSTI "#include \"$ATL_CUST_INC\"\n";
                close CSTI;
                }
	elsif(/^-set=(.+)$/i) 	{print STDERR "SET option not allowed\n";}
	elsif(/^-tdp=(.+)$/i) 	{print STDERR "TDP known as $ENV{'ATLTGT'}\n" if($ATTOLCC_VERBOSE || $ENV{'ATTOLSTUDIO_VERBOSE'});}
	elsif(/^-otc=(\"?)(.+)\1$/i) 	{@otc=split(/,/,$2);}
	elsif(/^-PAS/i)	{$ATCMODE=1;} #this option is not given to instrumentor
	elsif(/^-CCO\w*=fun.*$/i)	{$ATGMODE=1;$ATG_MODULE_AS=0;} #this option is not given to instrumentor
	elsif(/^-DCP/i)	{$DCPMODE=1;} #this option is not given to instrumentor
	elsif(/^-WCET/i)	{$ATQ_COMPUTE_MINMAX=2;}
	else {
		#is not a launcher option give it to instrumentor
		if((/ /) && !(/\"$/)){
		    if(/^(.+)=(.+)$/) {$instrumOpt .= $sp.$1."=".$cot.$2.$cot;}
		    else {$instrumOpt .=$sp.$cot.$_.$cot;}
		} else {
		  if(/(-(fdc|tsf)name=)([^\"][^ ]*)/i){$_=$1.$cot.$3.$cot;}
		  $instrumOpt .= $sp.$_;
		}
# set internal variables
		{
		  $_=uc($_);
		  #debug("instr option:$_");
		  $ATKMODE=1 if (/^-AU/); #AUTO_OTI
		  $ATAMODE=1 if (/^-APP/);#application profiling (common stack instrum)
		  $ATPMODE=1 if (/^-MEM/);#heap profiling
		  $ATGMODE=1 if (/^-CCO/);#ctrl coupling
		  $ATQMODE=1 if (/^-PERF/);
		  $ATL_CLOCK_KIND=1 if(/^-PERF.*=P/);
		  $ATTMODE=1 if (/^-TR/);#TRACE
		  $ATC_INFORMATION=1 if(/^-COMPA/);#1compact 2count
		  $ATC_INFORMATION=2 if(/^-COUN/);#1compact 2count
		  $ATCMODE=1 if ((/^-PAS/) || (/^-PR/) || (/^-BL/) || (/^-COND/));
		if (/^-STAC/){ $ATAMODE=1;$ATZMODE=1;}#Stack_size
		if (/^-MONI/){ $ATAMODE=1;$MNTMODE=1;}#variables monitoring
		}
	}
   }
   $ATCMODE=1 if ($ATC_INFORMATION ||
				!($ATKMODE|$ATPMODE|$ATQMODE|$ATTMODE|$ATMMODE|$MISRA_MODE|($ATAMODE & ($ATZMODE|$MNTMODE))|$ATGMODE|$DCPMODE));
   $IGNORE=",".join(',',@IgnoreList);
   $INSTRUM=",".join(',',@InstrumList) if(@InstrumList);
   #change instrum options according to CCoupling or DCoupling
   if($ATG_MODULE_AS==0 || $DCPMODE) {
		$ATCMODE=1;
		$instrumOpt .= ' -proc' unless($instrumOpt =~m/-pr/i);
		$instrumOpt .= ' -call' if(($instrumOpt !~m/-call/i));
		$instrumOpt .= ' -block' unless($instrumOpt =~m/-bl/i || $DCPMODE==0);
		$instrumOpt .= ' -cond' unless($instrumOpt =~m/-con/i || $DCPMODE==0);
   }
   # some check of options
   if($ATQ_COMPUTE_MINMAX) {
		$ATQMODE=1;
		$instrumOpt .= ' -perf' unless($instrumOpt =~m/-perf/i);
   }
}
###########################################################################
# force language option found in the compiler command line
sub force_language #($)
{
my $l = shift;
$force_lang=$l;

   if(($force_lang == 2)&&($lang ne "CPP")) {
      $INIFILE="tpcpp.ini";
      DecodeIniFile();
      }
   elsif(($force_lang ==1)&&($lang ne "C")) {
      $INIFILE="tp.ini";
      DecodeIniFile();
      }
   $lang=$Ini{'LANGUAGE'};
   $OBJEXT=$Ini{'OBJEXT'};
   $TDP_LANGUAGE = $lang;
   trace ("force language to $lang\n");
}

###########################################################################
# read_cmd
sub read_cmd #(@)
{
require "BatchCCDefaults.pl";
   my @argv=@_;
   if(!($argv[0]=~m/^-/) && (defined $ENV{ATTOLCC_OPT}) && (-f $ENV{ATTOLCC_OPT})){
	   # for special invocation format like >attolcc $(CC) .....
	   # options are read from the opt_file given by $ENV{ATTOLCC_OPT} under conditions:
	   # ATTOLCC_OPT variable is used to provide the option file and the first argv is the compiler name (not an option)
	   unshift(@argv,"--");
	   unshift(@argv,"-opt=$ENV{ATTOLCC_OPT}");
   }
   while((@argv) && (!$onCompiler))
   {
   	$_=shift(@argv);
	s/\"$// if(s/^\"//);#remove global cot
   	#decode instrum options
   	   if($_ eq "--"){#separator cmd
   	   	$onCompiler=1;
   	   }
	   elsif(/^-opt=(\"?)(.+)\1$|\@(\"?)(.+)\3$/i){ #" accept @optFile or -opt=optFile for options
	        my $fileOpt=$2.$4;
		# read the options in the file and push into the existing @argv to be analysed as other
		debug("read options file $fileOpt");
		if((open OPTIN,"<$fileOpt") || (open OPTIN,"<".$ENV{'TESTRTDIR'}."/lib/locale/".$fileOpt)){
			while (<OPTIN>){
				chomp($_);
				debug("[$_]");
				my @optInFile=splitArgs($_);
				push(@launcherOptions,@optInFile);
			}
			close OPTIN;
		}else{ $activ = 0; print STDERR &PerlTranslate("attolcc.pl", "Cannot open the file %1\n", "%1 is the file name", $fileOpt);}
	   }
	   elsif(/^-act=(\"?)(.+)\1$/i){
	   	$activ=$2;
	   	if(-f $activ) {
			open ACTIN,"<$activ" || die &PerlTranslate("attolcc.pl", "Cannot open the file %1\n\n", "%1 is the file name", $activ);
	   		while (<ACTIN>){
				chomp($_);
				$activ=$_;
	   		}
			close ACTIN;
	   	}
		$activ = 0 unless($activ =~ /^(y(es)?|1)$/i);
	   }
	   elsif(lc($_) eq "-help")	{usage();exit(0);}
	   elsif(lc($_) eq "--help")	{help();exit(0);}
	   elsif(/^-env_(.+)=(.+)$/i)	{$ENV{uc($1)}=$2;}
	   elsif(/^-treatmt=(.+)$/i) {
	   	my $t=$1;
		#debug("require additional treatment by $t");
		require $t;
	   }
	   elsif(/^-tmpdir=(\"?)(.+)\1/i) {
		$attolcc_tmpdir=$2;
		$attolcc_tmpdir=~s,\{PID\},$$,g;
		$INTDIR=$attolcc_tmpdir;
		mkpath($attolcc_tmpdir,0777) unless(-d $attolcc_tmpdir);
		$attolcc_tmpdir.=$PATH_SEPARATOR unless ($attolcc_tmpdir=~/[\/\\]$/);
		$envfile=$attolcc_tmpdir.$envfile;
	   }
	   elsif(/-notdp/i)   	{$no_tdp=1;}
	   elsif(/-parallel/i)  {$PID='.'.$$.'.';}
	   elsif(/-nolink/i)	{$link=0;}#with -nolink the link is done only if obj or lib file are on the cmd line
  	   else {
	  	   push(@launcherOptions,$_);
  	   }
   }#while @argv

   unless($activ) {
	   my $ret = system(@argv);
	   exit($ret);
   }

   $LOGFILENAME=$INTDIR.'/'.$launcher.$PID."files.log";
   $LOGFILENAME=~s,\{PID\},$$,g;
   $no_tdp=1 if($ENV{ATL_SHARED_TDP});
   $launcherStrOptions=join('',@launcherOptions);
   #debug($launcherStrOptions);
   if((!$no_tdp) && (-r $envfile)) {
		#debug("require $envfile");
		require $envfile;
		#force_tdp_cc =1 here means it was set at previous exec and so tdp generated yet
		$generateTdp=0 if($force_tdp_cc);
   }
   else
   {
   	printEnvironment();
	$ATCMODE=1; #no options=ATC
	$NAME="";
	$iniHasChanged=1;
	$firstExec=1;
   }
   #debug("launcher Options:  $launcherStrOptions env_=$launcherEnvOptions");

   DecodeIniFile();
   $lang=$Ini{'LANGUAGE'};
   $OBJEXT=$Ini{'OBJEXT'};
   $LIBEXT=$Ini{'LIBEXT'};
   $DLLEXT=$Ini{'DLLEXT'};
   $OUTDIR=$INTDIR;
   $ARCH64=1 if($Ini{ARCH64});

   # if the cmd line is the same no need to decode it, $envfile is decoded yet
   if($launcherEnvOptions ne $launcherStrOptions) {
   	read_Launch_cmd(@launcherOptions);
   	if($PID && !$no_tdp) {
		unless(-f $envfile) {rec_env($envfile.$PID.'tmp') ;}
		unless(-f $envfile) {rename($envfile.$PID.'tmp', $envfile) ;}
		unlink($envfile.$PID.'tmp');
   	}
   }

  #is not generated anymore 7.5.0.4 push(@filesToRemove,$LOGFILENAME) if($ATTOLCC_NOLIST);
   #some checks
   if(!$onCompiler) {
	#may be, we want to make the TDP only
   	if($force_tdp_cc) {
		#yes, we want to make the TDP only, Do it
		TDPcc();
		push(@filesToRemove,$envfile) unless ($KEEP); #we should be at link time so no need to keep this file
		removeFiles(0) ;
		#and do nothing else
		exit(0);
   	}
   	else {
		pError("$SMALL_PRODUCT_NAME-E-NOSEPF, command separator -- not found in command line");
		usage();
		exit(0);
	}
   }
   else #(!$onCompiler)
   {
   	#decode compilation command
   	my $stdComp=ParseCompilerArgs(@argv);
   	if(($compiler !~m/_org/) && ($Ini{INSTALL_PLUGIN} eq 'TRUE')){
		print STDERR "# TDP INSTALL_PLUGIN=TRUE changing compiler name\n";
		my ($d,$c,$e)=SplitFileName($compiler);
		$e='.'.$e if($e ne '');
   		$compiler=$d.$c."_org".$e;
   	}
   	if($stdComp){
	     my $ret=stdCompil();
	     $ret=$ret>>8 if($ret>256);
	     exit($ret);
	}
   	unless(@srcFilesToInstrum || (@objFiles) || $Link) {
   	     print STDERR "#No sources or Object file found. ";
   	     if(-r $envfile){
		     print STDERR "Assuming Link command\n";
		     $Link=1;
   	     } else {
		     print STDERR "Running command without instrumentation\n";
		     my $ret=stdCompil();
		     $ret=$ret>>8 if($ret>256);
		     exit($ret);
   	     }
	}
	$TpCflags=$CompilFlags if($TpCflags eq '');
	$APP_CFLAGS=$TpCflags if($firstExec); #memo for TP compilation
   }
   return 0;
}

###########################################################################
# TestRTcc_cmd
sub TestRTcc_cmd #(@)
{
   my @argv=@_;
   DecodeIniFile();
   $lang=$Ini{'LANGUAGE'};
   $OBJEXT=$Ini{'OBJEXT'};
   $LIBEXT=$Ini{'LIBEXT'};
   $DLLEXT=$Ini{'DLLEXT'};
   $attolcc_tmpdir=$OUTDIR.$PATH_SEPARATOR;
   $IGNORE=",".join(',',@IGNORE);
   $INSTRUM=",".join(',',@INSTRUM);
   $INSTRUM="" if($INSTRUM =~ /^,\s*$/);
   $ARCH64=1 if($Ini{ARCH64});

   	#decode compilation command
   	my $stdComp=ParseCompilerArgs(@argv);
   	if(($compiler !~m/_org/) && ($Ini{INSTALL_PLUGIN} eq 'TRUE')){
		print STDERR "# TDP INSTALL_PLUGIN=TRUE changing compiler name\n";
		my ($d,$c,$e)=SplitFileName($compiler);
		$e='.'.$e if($e ne '');
   		$compiler=$d.$c."_org".$e;
   	}
   	if($stdComp){
	     my $ret=stdCompil();
	     exit($ret);
	}
   #print "main::INTDIR=$main::INTDIR\n\n";
   $envfile=$INTDIR.'/TPflags.pl';
   if(-r $envfile) {
   	#debug("require $envfile");
   	require $envfile;
   } else {
        $iniHasChanged=1 if($USE_CFLAGS_TP);
	$TpCflags=$CompilFlags if($TpCflags eq '');
        $APP_CFLAGS=$TpCflags;
	#write compil flags found on the cmd line to help UI to learn them automatically
	if($LOGFILENAME ne ''){
		if(open( LOG, ">>$LOGFILENAME")) {
			print LOG "INC \"".join('","',@COMPLETE_INCLUDE_DIR_LIST)."\"\n" if(@COMPLETE_INCLUDE_DIR_LIST);
			print LOG "DEF \"".join('","',@GENERATION_CONDITION)."\"\n" if(@GENERATION_CONDITION);
			print LOG "FLG \"".$APP_CFLAGS."\"\n" if($APP_CFLAGS ne '');
			close LOG;
		} else {
			print STDERR "unable to open the file $LOGFILENAME\n";
		}
        }

   	#debug("TP flags will be $APP_CFLAGS");
   	#SystemL("set");
   }
   return 0;
}
###########################################################################
# instrumentation
# TestRTCC=1 means option comes from eclipse envTestRTcc.pl setting file and $instrumOpt is already computed by instrum.pl
sub instrumentation #($$$$)
{
   my ($lang,$in,$out,$bname)=@_;
   my $co;
   my $otifiles="";
   my $set= "";
   my $iopt=$instrumOpt.' '.$Ini{'INSTRUM_OPT'};
   print "TDP Instrum option:$Ini{'INSTRUM_OPT'}\n" if(($Ini{'INSTRUM_OPT'}) && ($ENV{'ATTOLSTUDIO_VERBOSE'}));
   $iopt=~s,\{PID\},$$,g;

   #TestRTCC=1 means option comes from eclipse envTestRTcc.pl setting file and $instrumOpt is already computed by instrum.pl
   unless($main::TestRTCC){ # compute instrum option regarding on line options
	   my @SETS=();
	   push(@SETS,"MINMAX") if ($ATQ_COMPUTE_MINMAX || $ATQ_COMPUTE_WCET);
	   push(@SETS,"WCET") if ($ATQ_COMPUTE_MINMAX>1 || $ATQ_COMPUTE_WCET);
	   push(@SETS,"CHECK_STACK") if($ATL_CHECK_STACK);
	   push(@SETS,"VOLATILDLL") if($ATL_USE_VOLATIL_DLL);
	   push(@SETS,"UNLOADDLL") if(lc($ATL_USE_VOLATIL_DLL) eq "this");
	   push(@SETS,"TPDLLIMPORT") if($ATL_RUNTIME_FORMAT eq "DLL");
	   push(@SETS,"NO_SYS_INCLUDE") if($NO_SYS_INCLUDE);
	   push(@SETS,"DYNTABLES") if($DYNTABLES);
	   push(@SETS,"ATCONTHEFLY") if($ATC_ON_THE_FLY);
	   push(@SETS,"MULTITHREAD") if($ATL_MULTI_THREADS);
	   push(@SETS,"LINENUMOPTIM") if($LINENUMOPTIM);
	   push(@SETS,"LIBRARY") if($ATL_MEM_LIB);
	   push(@SETS,"CUSTINC") if($ATL_CUST_INC);
	   push(@SETS,"LINKSECTION") if($LINKSECTION);
	   $set= " -SET=".join(",",@SETS) if(@SETS);
   }
   if (!($instrumOpt =~ /-comment=/i)) {
	   $co=$PreproFlags;
	   $co =~s/\\\"//g;#\ "
	   $co =~s/\"//g;
	   $co =~s/,/ /g;
	   $co="-COMMENT=\"Preprocessing Flags:$co\"";
   }
   if($iopt=~ /-fdcname=\"([^\"]*)\"/i)
   {
   	my $file=$1;
   	unless ($file=~ /\.fdc$/){
   	    if(( -d $file) || ($file=~ /[\\\/]$/)){
   	    	mkpath($file,0777) unless(-d $file);
   	    	$file.='/'.$bname;
   	    }
   	    $iopt=~ s!-fdcname=\"[^\"]*\"!-fdcname=\"$file.fdc\"!i;
   	}
   }
   if($iopt=~ /-tsfname=\"([^\"]*)\"/i)
   {
   	my $file=$1;
   	unless ($file=~ /\.tsf$/){
   	    if(( -d $file) || ($file=~ /[\\\/]$/)){
   	    	mkpath($file,0777) unless(-d $file);
   	    	$file.='/'.$bname;
   	    }
   	    $iopt=~ s!-tsfname=\"[^\"]*\"!-tsfname=\"$file.tsf\"!i;
   	}
   }
   if($PID){
   	unless($iopt=~ /-fdc[nd]/i){
	    $iopt.=" -fdcname=\"$INTDIR/$bname.fdc\"";
   	}
   	unless($iopt=~ /-tsf[nd]/i){
	    $iopt.=" -tsfname=\"$INTDIR/$bname.tsf\"";
   	}
   }
   $otifiles= '-otifile="'.join('","',@oti).'"' if (@oti);
   print STDERR ">instrumentation of $in to $out\n";
   unlink($out);
   my $studioLog=""; $studioLog="-studio_log=\"$LOGFILENAME\"" unless($ATTOLCC_NOLIST);
   my $attolccV="attolcc4"; $attolccV="attolccp" if($Ini{USE_ATTOLCCP} || $ENV{USE_ATTOLCCP});
   if($lang eq "CPP") { # C++
      return SystemLI($BINPATH."$attolccV $cot$in$cot $cot$out$cot atl.hpp atl.opp $iopt $set $otifiles $studioLog $co");
   }
   if($Ini{USE_ATTOLCC1} || $ENV{USE_ATTOLCC1})
   {
      return SystemLI($BINPATH."attolcc1 $cot$in$cot $cot$out$cot atct.def $iopt $set $studioLog $co");
   }
   else
   {
      my $deffile="atus_c.def atl.opp";
      $deffile   ="atus_c.def atl.opt" if(-f "$TARGETDIR/ana/atl.opt");
      return SystemLI($BINPATH."$attolccV $cot$in$cot $cot$out$cot $deffile $iopt $set $studioLog $co");
   }

}

###########################################################################
# prepro contract check
sub preproOtc #($$)
{
   my ($in,$out)=@_;
   print STDERR ">preprocessing of $in\n";
   unlink($out);
   my $studioLog=""; $studioLog="-studio_log \"$LOGFILENAME\"" unless($ATTOLCC_NOLIST);
   my $ret= SystemLI($BINPATH."atoprepro $cot$in$cot -G C++ -OTI $cot$out$cot -O $INTDIR/temp_cc -TDF unused_tdf -E 30 $Ini{'PREPRO_OPT'} $studioLog");
   unlink("$INTDIR\temp_cc");
   return $ret
}

###########################################################################
# OutFileFound called when the force out file is found on the command line
#		register the requested name of the object file to generate and/or its directory
#		to register a directory the path must ends by a path separator
sub OutFileFound #($)
{
my $of=shift;
$OutFile=$of;
}

###########################################################################
# SourceFileFound called when a source file is found on the commande line
sub SourceFileFound #($)
{
my $sf=shift;
push(@srcFilesToInstrum,$sf);
}

###########################################################################
# Setting called to set a TDP setting on special compiler option
sub Setting #($$)
{
my ($set,$val)=@_;
        $settings{$set}=$val;
	eval "\$$set=\"$val\"";
}

###########################################################################
# NoLink called when the no link flag is found in the command line
sub NoLink
{
$link=0;
}

###########################################################################
# diffBetweenPreproAndCompil called when prepro use options which is not used on compil
# force to preprocess before compil even without instrum
sub diffBetweenPreproAndCompil
{
#debug("diffBetweenPreproAndCompil");
$pc_cmdDiff=1;
}

###########################################################################
# start called at first execution allow to initialize the instrumentation
sub start
{
    my $rep;
    my $firstline;
    if(@otc)
    {
    	foreach $otcfile (@otc)
    	{
    	    my ($d,$n,$e)=SplitFileName($otcfile);
    	    $d=$attolcc_tmpdir if($attolcc_tmpdir ne "");
    	    my $otifile=$d.$n.".oti";
    	    preproOtc( $otcfile , $otifile);
    	    push (@oti,$otifile);
    	    $ATKMODE=1;
    	}
	$model = "$TARGETDIR/lib/options_model.h";
	$options = "$INTDIR/options.h";

	MakeCProductsHeaderFile ($model, $options);
    }
}
###########################################################################
# TDPBatchCC
sub TDPcc
{

$generateTdp=0;
	return 0 if($ATL_RUNTIME_FORMAT eq "NONE");
	$ATL_RUNTIME_FORMAT="OBJ" if($ATL_RUNTIME_FORMAT eq "");
	$USE_UNLOAD_DLL ="VOLATILDLL" if($ATL_USE_VOLATIL_DLL);
	$USE_UNLOAD_DLL.=",UNLOADDLL" if(lc($ATL_USE_VOLATIL_DLL) eq "this");
	if($ATL_RUNTIME_FORMAT eq "OBJ") {
		$TP_CCFLAGS=$Ini{'DEFAULT_TPLIB_CCFLAGS'};
		$TP_LDFLAGS=$Ini{'DEFAULT_TPLIB_LDFLAGS'};
	}
	$MIME_NAME='ISO-8859-1' if($MIME_NAME eq "");
	# .....
		my ($d,$n,$e)=SplitFileName($objFiles[0]);
	$EXENAME=$n.'.'.$EXEEXT	unless($EXENAME);
	$NAME=$n unless($NAME);
	unless($EXENAME){
		($d,$n,$e)=SplitFileName($srcFilesToInstrum[0]) ;
		$EXENAME=$n.'.'.$EXEEXT;
		$NAME=$n unless($NAME);
	}
	$NAME = "root" unless($NAME);

	# Something to get the well known and unique out file
	$ATL_OUT_FILE = "atlout.spt" if($ATL_OUT_FILE eq "");
	#$ATL_OUT_FILE = $ATL_TRACES_FILE if ($ATL_TRACES_FILE ne "");

	unless($ATTOLCC_NOLIST) {
		open( LOG, ">>$LOGFILENAME") || print STDERR "unable to open the file $LOGFILENAME\n";
		print LOG "EXE $EXENAME\n";
		my $sptOpt="A"; #describe what is involved in the result file
		$sptOpt.="A" if($ATAMODE);
		$sptOpt.="Z" if($ATZMODE && $ATAMODE);
		$sptOpt.="G" if($ATGMODE);
		$sptOpt.="D" if($DCPMODE);
		$sptOpt.="P" if($ATPMODE);
		$sptOpt.="Q" if($ATQMODE);
		$sptOpt.="q" if($ATQ_COMPUTE_MINMAX==2);
		$sptOpt.="O" if($MNTMODE && $ATAMODE);
		if($ATTMODE) {
			$sptOpt.="T";
			$TDFFILE="tracer.tdf" if($TDFFILE eq "");
			if($ATT_ON_THE_FLY) {
				print LOG "TDF $TDFFILE\n";
				$sptOpt.="f";
			}
		}
		if($ATCMODE) {
			$sptOpt.="C";
			$ATC_TIO_NAME="attolcov.tio" if($ATC_TIO_NAME eq "");
			if($ATC_ON_THE_FLY) {
				print LOG "TIO $ATC_TIO_NAME\n";
				$sptOpt.="f";
			}
		}
		#for studioreport to recover tdp & instrum reports & file to split
		print LOG "#OPT $sptOpt \"$NAME\"\n";
		print LOG "#TGT $TARGETDIR\n";
		my $name=$ATL_OUT_FILE;
		$name=$ATL_TRACES_FILE if($ATL_TRACES_FILE);
		$HOST_SPT=$Ini{HOST_SPT} unless($HOST_SPT);
		if($HOST_SPT ne ''){
			my $hname=$HOST_SPT;
			if($hname=~ m/[\\\/]$/){ #it is a directory not a file
				my ($d,$n,$e) = SplitFileName($name);
				$hname.=$n.'.'.$e;
			}
			$name=$hname;
		}
		$name=~s/(.*\.)(\w{3})$/$1\*.$2/ if($ATL_MULTI_PROCESS);
		print LOG "SPT $name\n";
	}
	close LOG;
	if($ENV{'ATL_NO_TDP_COMPILE'})
	   {
		print STDERR ">Products.h generation only because ATL_NO_TDP_COMPILE is set\n";
		my $model = "$TARGETDIR/lib/products_model.h";
		my $header = "$INTDIR/products.h";
		MakeCProductsHeaderFile($model,$header);
		return 0;
	   }
	if($ATSMODE)
	   {
		print STDERR ">options.h generation\n";
		my $model = "$TARGETDIR/lib/options_model.h";
		my $header = "$INTDIR/options.h";
		MakeCProductsHeaderFile($model,$header);
	   }
	if($CFLAGS == 1){
 		#debug( "found \$CFLAGS=$CFLAGS; \$TP_CCFLAGS=$TP_CCFLAGS;\n");
		$CFLAGS="";
		if($TP_CCFLAGS eq ""){
			$TP_CCFLAGS=$APP_CFLAGS;
			@GENERATION_CONDITION=();
			@COMPLETE_INCLUDE_DIR_LIST=();
			$Ini{COMPILER}=$APP_COMPILER if($APP_COMPILER ne '');
		}
	}else{
		#-----this part comes from TDPBachCC.pl-------------------------------------

		# If no overload for them, $CPPFLAGS, $CFLAGS, @COMPLETE_INCLUDE_DIR_LIST and
		# @GENERATION_CONDITION come from ini file:

		#prepro flags
		unless (defined($settings{CPPFLAGS})) {
		  $CPPFLAGS = $Ini{'DEFAULT_CPPFLAGS'};
		}
		if ($ADDFLAGS ne "") {
		  $CPPFLAGS .= $ADDFLAGS;
		}
		if($^O =~ /Win32/) {while($CPPFLAGS=~ /\$(\w+)/){my $v=$1;$CPPFLAGS=~ s/\$$v/$ENV{$v}/g;}}

		#compiler flags
		unless (defined($settings{CFLAGS})) {
		  $CFLAGS = $Ini{'DEFAULT_CFLAGS'};
		}
		if($^O =~ /Win32/) {while($CFLAGS=~ /\$(\w+)/){my $v=$1;$CFLAGS=~ s/\$$v/$ENV{$v}/g;}}
		#debug( "\$CFLAGS=$CFLAGS \n###> \$CPPFLAGS=$CPPFLAGS\n");

  		#include paths
		if (defined($settings{INCLUDE_PATHS})) {
		  if($^O =~ /Win32/) {while($INCLUDE_PATHS=~ /\$(\w+)/){my $v=$1;$INCLUDE_PATHS=~ s/\$$v/$ENV{$v}/g;}}
		  @COMPLETE_INCLUDE_DIR_LIST = split( /,/, $INCLUDE_PATHS);
		} else {
		  if ($Ini{'DEFAULT_INCLUDE_PATHS'} ne "") {
		    if($^O =~ /Win32/) {while($Ini{'DEFAULT_INCLUDE_PATHS'}=~ /\$(\w+)/){my $v=$1;$Ini{'DEFAULT_INCLUDE_PATHS'}=~ s/\$$v/$ENV{$v}/g;}}
		    @COMPLETE_INCLUDE_DIR_LIST = split( /,/, $Ini{'DEFAULT_INCLUDE_PATHS'} );
		  }
		}
		#debug( "\$INCLUDE_PATHS=$INCLUDE_PATHS ; @COMPLETE_INCLUDE_DIR_LIST\n");

		#macro definitions
		if (defined($settings{DEFINES})) {
		  if($^O =~ /Win32/) {while($DEFINES=~ /\$(\w+)/){my $v=$1;$DEFINES=~ s/\$$v/$ENV{$v}/g;}}
		  @GENERATION_CONDITION = split( /,/, $DEFINES);
		} else {
		  if ($Ini{'DEFAULT_DEFINES'} ne "") {
		    if($^O =~ /Win32/) {while($Ini{'DEFAULT_DEFINES'}=~ /\$(\w+)/){my $v=$1;$Ini{'DEFAULT_DEFINES'}=~ s/\$$v/$ENV{$v}/g;}}
		    @GENERATION_CONDITION = split( /,/, $Ini{'DEFAULT_DEFINES'} );
		  }
		}
  		#debug( "\$DEFINES=$DEFINES ; @GENERATION_CONDITION\n");
	}

	#----------------------------------------------------------------------------
	print STDERR ">TDP generation...\n";
	# Let's do it
	if (MakeTargetPackageObject()) {
	  # Some errors while compiling TDP library
	  if(($TP_CCFLAGS eq '') && ($APP_CFLAGS ne '')) {
		print STDERR &PerlTranslate("attolcclib.pl", "The option --cflags can be set to compil TP with same flags as application sources.\nTo get more help, type attolcc --help\n", "");
	  }
	  return 1;
	}
	return 0;
}

###########################################################################
# add all fileNames listed into an external .lst file to the IgnoreList array
# .lst file may include an other .lst file.
sub ignoreFromFile #($)
{
my $f =shift;
pushFromFile($f,@IgnoreList);
}

###########################################################################
# add all fileNames listed into an external .lst file to the List array
# .lst file may include an other .lst file.
sub pushFromFile #($\@)
{
my ($f,@IList) = @_;

my @list=();
my $fl;
trace("#ignore/intrum list From File:$f");
open IGN, "<$f" || return &PerlTranslate("attolcc.pl", "Cannot open the file %1\n", "%1 is the file name", $f);
while(<IGN>)
   {
	chomp;
   	@files=split(/,/,$_);
	push(@list,@files);
   }
close(IGN);
foreach(@list)
   {
	$fl=$_;
	if((/\..{1,3}$/) && !(grep(/^$fl$/,@IList))) {
	   $fl=~ s/\\/\//g;
	   #debug("fromFile:$fl");
	   push(@IList,$fl);
	   if($fl =~/\.lst$/) { pushFromFile($fl,@IList);}
	}
   }
}


###########################################################################
# record launcher and instrum options and settings into env_xxxxx.pl
# to memorize them between each instrum/compil file and reuse it at link time
sub rec_env
{
my $file=shift;
my $s;
#debug("write file:$envfile");
open EN, ">$file" || die &PerlTranslate("attolcclib.pl", "Cannot open the file %1\n\n", "%1 is the file name", $file);
unless($main::TestRTCC) {
	print EN "# $launcher configuration:\n";
	print EN "\$launcherEnvOptions='$launcherStrOptions';\n";
	print EN "\$INIFILE='$INIFILE';\n";
	print EN "\$INTDIR='$INTDIR';\n";
	print EN "\$NOSTOP=$NOSTOP;\n";
	print EN "\$KEEP=$KEEP;\n";
	print EN "\$showCmd=$showCmd;\n";
	print EN "\$ATTOLCC_VERBOSE=$ATTOLCC_VERBOSE;\n";
	print EN "\$ENV{ATTOLSTUDIO_VERBOSE}=1;\n" if($ATTOLCC_VERBOSE>1);
	print EN "\$force_tdp_cc=$force_tdp_cc;\n";
	print EN "\$ATTOLCC_LOGNAME='$ATTOLCC_LOGNAME';\n";
	print EN "\$ATTOLCC_LOGFILE=$ATTOLCC_LOGFILE;\n";
	print EN "\$ATTOLCC_NOLIST=$ATTOLCC_NOLIST;\n";
	print EN "\$IGNORE='$IGNORE';\n";
	print EN "\$INSTRUM='$INSTRUM';\n";
	my $attolcc_tmpdir2=$attolcc_tmpdir;
	$attolcc_tmpdir2=~ s/\\/\\\\/g;
	print EN "\$attolcc_tmpdir='$attolcc_tmpdir2';\n";
	print EN "\@oti=(\"".join('","',@oti)."\");\n" if(@oti);
	print EN "\$force_lang=$force_lang;\n";
	print EN "\$force_tdp_lang=$force_tdp_lang;\n";
	print EN "\$TDP_LANGUAGE='$TDP_LANGUAGE';\n";
	print EN "\$instrumOpt='$instrumOpt ';\n";
	print EN "# instrumentation options:\n";
	print EN "\$ATAMODE=$ATAMODE;\n" if($ATAMODE);
	print EN "\$ATZMODE=$ATZMODE;\n" if($ATZMODE);
	print EN "\$ATGMODE=$ATGMODE;\n" if($ATGMODE);
	print EN "\$DCPMODE=$DCPMODE;\n" if($DCPMODE);
	print EN "\$ATKMODE=$ATKMODE;\n" if($ATKMODE);
	print EN "\$ATPMODE=$ATPMODE;\n" if($ATPMODE);
	print EN "\$ATQMODE=$ATQMODE;\n" if($ATQMODE);
	print EN "\$ATCMODE=$ATCMODE;\n";
	print EN "\$MNTMODE=$MNTMODE;\n" if($MNTMODE);
	print EN "\$ATTMODE=$ATTMODE;\n" if($ATTMODE);
	print EN "\$ATL_CLOCK_KIND=$ATL_CLOCK_KIND;\n" if($ATL_CLOCK_KIND);
	print EN "\$ATC_INFORMATION=$ATC_INFORMATION;\n" if($ATC_INFORMATION);
	if($ATMMODE){
	print EN "\$ATMMODE=$ATMMODE;\n";
	print EN "\$MET_ONE_LEVEL=$MET_ONE_LEVEL;\n";
	print EN "\$MET_IN_SOURCE_DIR=$MET_IN_SOURCE_DIR;\n";
	print EN "\$metdir=\"$metdir\";\n";
	print EN "\@MET_RESTRICT_DIR=(\"".join('","',@MET_RESTRICT_DIR)."\");\n" if(@MET_RESTRICT_DIR);
	#print EN "\$MET_OPTIONS=\"$MET_OPTIONS\";\n";
#	print EN "\@MET=(\"".join('","',@MET)."\");\n";
	}
	if($MISRA_MODE){
	$MISRA_CONF=~s/\\/\//g;
	print EN "\$MISRA_MODE=$MISRA_MODE;\n" ;
	print EN "\$MISRA_CONF=\"$MISRA_CONF\";\n";
#	print EN "\@XOB=(\"".join('","',@XOB)."\");\n";
	}
	print EN "# Node settings:\n";
	print EN "\$NAME='$NAME';\n";
	foreach $key (keys %settings) {
	print EN "\$$key='$settings{$key}';\n";
	print EN "\$settings{$key}='",$settings{$key},"';\n";
	#print EN "print \"setting:$key=\$$key\\n\";\n";
	}
	#print EN "print \"loading conf.....\";\n";
   }
   print EN "#flags for TP compilation\n";
   print EN "\$APP_CFLAGS='$APP_CFLAGS';\n";
   print EN "\$APP_COMPILER='$compiler';\n";
	print EN "#FOUND_INCLUDE_DIR=(\"".join('","',@COMPLETE_INCLUDE_DIR_LIST)."\");\n" if(@COMPLETE_INCLUDE_DIR_LIST);
	print EN "#FOUND_DEFINES=(\"".join('","',@GENERATION_CONDITION)."\");\n" if(@GENERATION_CONDITION);
   print EN "1;\n";
   close(EN);
   $iniHasChanged=0;
}

###########################################################################
# remove all file from a list
sub removeFiles
{
my $kept=shift;
   foreach $fl (@filesToRemove)
   {
    if(-r $fl){
      if($kept){
	if($main::TestRTCC){
		trace("#rename file $fl");
		rename($fl,$fl.".bak");
	}
      }else{
        trace("#remove file $fl");
	unlink($fl) ;
      }
    }
   }
   @filesToRemove=();
}

sub pError #($)
{
my $s=shift;
print STDERR "#?$s\n";
print BLOG "#?$s\n" if($ATTOLCC_LOGFILE);
}

sub trace #($)
{
my $s=shift;
print STDERR $s."\n" if($ATTOLCC_VERBOSE || $ENV{'ATTOLSTUDIO_VERBOSE'});
print BLOG $s."\n" if($ATTOLCC_LOGFILE);
}

###########################################################################
# execute system command and get stderr and stdout to generate log
sub SystemL
{
     my @Command=@_;
     my $Ret;
     my $Err;
     my $status;
     my $Cmd=join(' ',@Command);
     trace($Cmd);
     if($showCmd){ return 0;}
     if($ATTOLCC_LOGFILE){
	open(OLDOUT,">&STDOUT");
	open(OLDERR,">&STDERR");
	open(STDOUT,">$StdOutFile");
	open(STDERR,">$StdErrfile");
	}

#     $Ret=system($Cmd);
     if($ARCH64 && $OS64==0){
	$Ret=system64(@Command);
     } else {
	$Ret=system(@Command);
     }

     $Err=$!;

     if($ATTOLCC_LOGFILE){
	close(STDOUT);open(STDOUT,">&OLDOUT");
	close(STDERR);open(STDERR,">&OLDERR");
	close(OLDOUT);close(OLDERR);
	}
	$status=ReturnAnalysis($Ret,$Err);

     if($ATTOLCC_LOGFILE){
	open(File,"<$StdOutFile"); print BLOG "stdout:\n";while(<File>) {print;print BLOG;} close(File);
	open(File,"<$StdErrFile"); print BLOG "stderr:\n";while(<File>) {print STDERR ;print BLOG;} close(File);
	unlink($StdErrFile);unlink($StdOutFile);
	}
     return $status;
}

sub SystemLI
{
     my @Command=@_;
     my $sav=$ARCH64;
     $ARCH64=0;
     my $status=SystemL(@Command);
     $ARCH64=$sav;
     return $status;
}
###################################### BEGIN ######################################################
sub Attolcc
{
my $status;
if($main::TestRTCC){
	$status=TestRTcc_cmd(@ARGV);

}else{
	$status=read_cmd(@ARGV);
}
my $phase;
if($ATTOLCC_LOGFILE) {
	my $lf=$ATTOLCC_LOGNAME;
	$lf=~s/(Log\.log)/$PID$1/;
	open BLOG, ">>$lf" || print STDERR "Unable to write the file $lf\n";
}

print STDERR "$SMALL_PRODUCT_NAME-I-STARTEXEC, $TESTRT_RR_NAME instrumentation driver $VERSION\n";
print STDERR "$SMALL_PRODUCT_NAME-I-COPYRIGHT, $COPYRIGHTMSG\n";
start() if($firstExec);
$CompilFlags.=$IncludeFlag.$cot.$TARGETDIR.$PATH_SEPARATOR."lib".$cot.$sp if($Ini{'NOPATH'});
foreach $s (@srcFilesToInstrum){
   if($status==0){
      #  @filesToRemove=();
        my $noInstrum=0;
	my $phaseCode=0;
	my $pathFile=absolutePath($s);
	$pathFile=~ s/\\/\//g;
   	my ($dir,$name,$ext) = SplitFileName($s);
	my $o=$name.".".$Ini{'OBJEXT'};
	if($OutFile) {
		$o=$OutFile;
	     if($OutFile =~/[\\\/]$/){ # it is a directory not a file
	        $o.=$name.".".$Ini{'OBJEXT'};
	        $dir=$OutFile;
	        if($attolcc_tmpdir eq "") {
	        	$INTDIR=$OutFile;
	        	$INTDIR=~s/[\\\/]+$//;
	        }
	     }
	}
	my $p=$dir.$name.$Pext;
	my $i=$dir.$name.$Iext.".".$ext;
   	if($attolcc_tmpdir ne "") {
	   	$p=$attolcc_tmpdir.$name.$Pext;
		$i=$attolcc_tmpdir.$name.$Iext.".".$ext;
	}
	push(@objFiles,$o);
	my $relFile=$s;
	$relFile =~ s/\\/\//g;
	my $fileSource=$name.'.'.$ext;
	if(($INSTRUM ne "") && !(  ($INSTRUM=~ /\Q,$fileSource\E/)
				 ||($INSTRUM=~ /\Q,$relFile\E/)
				 ||($INSTRUM=~ /\Q,$pathFile\E/) )){
		$status=1; #no instrumentation for this file
		$noInstrum=1;
		$phase="log. $s not instrumented. -instrum used (no error)";
		trace("#no instrumentation for $s -instrum=$INSTRUM");
	}
	#debug("find:($relFile|$pathFile|$fileSource) in $IGNORE");
	if(($IGNORE =~ /\Q,$fileSource\E/)
	  ||($IGNORE =~ /\Q,$relFile\E/)
	  ||($IGNORE =~ /\Q,$pathFile\E/)
	  ||(grep(/^$ext$/,@asmExtList)) ){
		$status=1; #no instrumentation for this file
		$noInstrum=1;
		$phase="log. $s not instrumented. -ignore used (no error)";
		trace("#no instrumentation for $s (ignored)");
	}
	elsif($force_lang ==0){ #lang has never ben forced
	   if((grep(/^$ext$/,@cppExtList)) && ($ext ne $ENV{ATL_C_EXT})) { # C++
		if($INIFILE ne "tpcpp.ini") {
			$iniHasChanged=1; #env_attolcc.pl must be written
			$TpCflags=$CompilFlags if($TpCflags eq '');
			$APP_CFLAGS=$TpCflags; #memo flags used for the last c++ compil
			$INIFILE="tpcpp.ini";
			DecodeIniFile();
			$lang=$Ini{'LANGUAGE'};
			if($force_tdp_lang ==0){
			   #debug("TDP_LANGUAGE=$TDP_LANGUAGE");
			   $generateTdp=1 if($TDP_LANGUAGE ne $lang);
			   $TDP_LANGUAGE = $lang;
			   }
			$OBJEXT=$Ini{'OBJEXT'};
			#debug("lang=$lang, obj=$OBJEXT");
		}
	   } elsif(grep(/^$ext$/,@cExtList)) {
		if($INIFILE ne "tp.ini") {
			$iniHasChanged=1; #env_attolcc.pl must be written
			$INIFILE="tp.ini";
			#we don't save language modif if cpp has been found TDP must be cpp
			#debug("lang=C");
			DecodeIniFile();
			$lang=$Ini{'LANGUAGE'};
			$OBJEXT=$Ini{'OBJEXT'};
		}
	   }
	}
	if($ATTOLCC_LOGFILE) {print BLOG "cd ".$pwd."\n";}
	#debug("\$pc_cmdDiff=$pc_cmdDiff\n");
	if($ATCMODE || $ATTMODE || $ATKMODE || $ATPMODE || $ATQMODE || ($ATAMODE && ($ATZMODE || $MNTMODE)) || $ATGMODE || $DCPMODE  ||$pc_cmdDiff) {

		if (($status==0)&&($TreatmentOnSource)) {
			$phase="treatment of $s";
			$s=TreatmentSource($lang,$s);
			EndStep(0);
		}
		if (($status==0)&&!($s=~/\.i$/)) {
			$phase="preprocessing of $s";
			$phaseCode=1;
			my ($d,$c,$e)=SplitFileName($compiler);
			$c=~s/_org$//;
			my ($f,$g,$h)=SplitFileName($Ini{COMPILER});
			$g=~s/_org$//;
			print STDERR &PerlTranslate("attolcclib.pl", "Warning: The compiler %1 Does not match the select TDP COMPILER key (%2)\n", "%1 is compiler Name %2 is the TDP COMPILER key value", $compiler, $Ini{COMPILER}) if($c ne '' && $c ne $g);
			push(@filesToRemove,$p);
			$status=preprocessing($lang,$s,$p);
			#debug("status=$status\n");
			EndStep(0);
		}
		if (($status==0)&&($TreatmentOnPreprocessed)) {
			$phase="treatment of $p";
			$p=TreatmentPreprocessed($lang,$p);
			EndStep(0);
		}
		if ($status==0) {
			$phase="instrumentation of $p";
			$phaseCode=2;
			$i=~s/\.i$/\.$Ini{'SRCEXT'}/;
		    if($ATCMODE || $ATTMODE || $ATKMODE || $ATPMODE || $ATQMODE || ($ATAMODE && ($ATZMODE || $MNTMODE)) || $ATGMODE || $DCPMODE ) {
			push(@filesToRemove,$i);
			$status=instrumentation($lang,$p,$i,$name);
			#debug("status=$status\n");
		    }else{
			print STDERR ">rename $p to $i\n";
			rename($p,$i);
			push(@filesToRemove,$i);
		    }
		    EndStep($status);
		}
		if (($status==0)&&($TreatmentOnInstrumented)) {
			$phase="treatment of $i";
			$i=TreatmentInstrumented($lang,$i);
			EndStep(0);
		}
	}else{ $i=$s; }
	if ($status==0) {
		$phase="compilation of $i to $o";
		$phaseCode=3;
		$status=compilation($lang,$i,$o);
	   	#debug("status=$status\n");
		EndStep($status);
		removeFiles(($KEEP || $status));
	}
	if (($status==0) && $ATMMODE) {
		if($metdir eq "") {
			if($attolcc_tmpdir) {
				$metdir=$attolcc_tmpdir ;
			} else {
				$metdir=".";
			}
		}
		$metdir=~s/[\\\/]$//;
		$metdir=~s/\\/\//g;
		trace (&PerlTranslate("attolcclib.pl", "%1: Static Metrics Computing...\n", "%1 is file to be compiled", $s));
		EndStep(metricsC ($TDP_LANGUAGE, $s, $LOGFILENAME, $metdir));
	}
	if (($status==0) && $MISRA_MODE){
		my $xob=codeChecker_cc($s);
#		push(@XOB,$xob);
#		job done by readLogFile: $iniHasChanged=1;
		EndStep(0);
	}
	if (($status==0)&&($TreatmentOnObject)) {
		$phase="treatment of $o";
		$o=TreatmentObject($lang,$o);
		EndStep(0);
	}
	if ($status && ($NOSTOP || $phaseCode==0)) {
		@filesToRemove=();#keep file when error
		if(!$link && (scalar(@srcFilesToInstrum)==1)) {#general case with makefile
			pError("$SMALL_PRODUCT_NAME-W-STDCMP, Launching standard compilation");
			print STDERR join(' ',($compiler,@compOriginal)),"\n" if ($ENV{'ATTOLSTUDIO_VERBOSE'});
			$status = stdCompil(); # original cmd from cmd line
		   	#debug("status=$status\n");
		   } else {#when the cmd involve more files
		   if($phaseCode==0){
		   	$phaseCode=1;# compil of the source at least
		   	if($pc_cmdDiff){#cmd may diff, so use the prepro first
			    pError("$SMALL_PRODUCT_NAME-W-PREWOI, precompilation without instrumentation");
			    $status=preprocessing($lang,$s,$p);
		   	    if($status==0){$phaseCode=2}# then compil the preprocessed file if ok
		   	    }
			}
		   if($phaseCode==2 || $phaseCode==3) { #err in phaseCode = 2 or 3, So compile the preprocessed file
			pError("$SMALL_PRODUCT_NAME-W-CMPWOI, compilation without instrumentation");
			my $iFile="attol_src.".$ext;
			trace("#copy $p to attol_src.$ext for compilation");
			copy($p,$iFile);
			$status=compilation($ext,$iFile,$o); # cmd build, without other sources lib ....
			$phaseCode=1;# to use the next compil if status bad
			unlink ($iFile);
		   	#debug("status=$status\n");
		   	}
		   if($phaseCode==1 && $status) { #last chance but not sure cmd may not be good
			pError("$SMALL_PRODUCT_NAME-W-SCPWOI, source compilation without instrumentation");
			$status=compilation($ext,$s,$o); # cmd build, without other sources lib ....
		   	#debug("status=$status\n");
			}
		   }

		if($phaseCode) {
			open  ELOG,">>$launcher.log" || die &PerlTranslate("attolcc.pl", "Cannot open the file %1\n\n", "%1 is the file name", "$launcher.log");
			my $date = GetDate();
			print ELOG "####$date error at $phase\n";
			print ELOG "cd ".$pwd."\n";
			print ELOG "$launcher ".join(" ",@ARGV)."\n";
			close(ELOG);
			}
		}
		#debug("generateTdp=$generateTdp force=$force_tdp_cc");
		$status=TDPcc() if($status==0 && $force_tdp_cc && $generateTdp);
        }
   }
$link=0 unless(@objFiles || $Link);

if($link && ($MISRA_MODE || $ATMMODE || ($ATAMODE && $MNTMODE))){
	readLogFile('xms');
	codeChecker_link() if(@XOB);
	metricLink() if(@MET);
}
if($status==0 && $link) {
   my $tpObj="";
   $main::TestRTCC=2 if($main::TestRTCC); #2 means link step detected
   if($ATCMODE || $ATTMODE || $ATKMODE || $ATPMODE || $ATQMODE || ($ATAMODE && ($ATZMODE|| $MNTMODE)) || $ATGMODE || $DCPMODE ) {
	   $status=TDPcc() if($generateTdp && !$no_tdp);
	   my $e=$OBJEXT;
	   if($ATL_RUNTIME_FORMAT ne "OBJ"){
	      $e=$LIBEXT;
	      if($ATL_RUNTIME_FORMAT eq "DLL"){
	         $e=$DLLEXT;
	         #visual uses lib to link with dll
	         $e=$Ini{LIBDLLEXT} if($Ini{LIBDLLEXT});
	      }
	   }
	   $tpObj=GetTargetPackageLib($e);
	   $tpObj="" if($ATL_RUNTIME_FORMAT eq "NONE");
	   $tpObj=$ENV{ATL_SHARED_TDP} if($ENV{ATL_SHARED_TDP});
   }
   if (($status==0)&&($TreatmentBeforeLink)) {
	$phase="treatment of Link";
	TreatmentLink($lang);
	EndStep(0);
   }
   $status=Link($tpObj)if($status==0);
   #debug("status=$status\n");
   EndStep($status);
   $iniHasChanged=0;
   unlink($envfile.".log");
   rename($envfile,$envfile.".log");#finished, so no need to keep this file
   unless($main::TestRTCC) {
    if ($ATTOLCC_NOLIST) {
      unlink($LOGFILENAME);
    } else {
      my $xtp=$INTDIR.'/'.$launcher."Report.xtp";
      rename($LOGFILENAME,$xtp) ;
      if($PID){ # concat all studio_log files and remove them
   	if(opendir(DIR,$INTDIR))
   	{
   	    my $d;
	    while($d=readdir(DIR)) {
		next unless ($d=~m/\Q$launcher\E\.\d+\.files\.log$/);
   		Cat($xtp,$d);
   		unlink($d);
	    }
	    closedir(DIR);
   	}
      }
    }
   }
}

close(BLOG) if($ATTOLCC_LOGFILE);
rec_env($envfile) if ($iniHasChanged && $status==0 && !($no_tdp) && (@objFiles));
removeFiles(($KEEP || $status));
if ($status){
	trace("exit status $status") ;
	exit($status);
}
exit(0) unless($main::TestRTCC); #it is end for attolcc but it should continue for TestRTcc (eclipse)
}


1;
