#!perl -w
#################################################################################
#
#  Licensed Materials - Property of IBM
#  Restricted Material of IBM
#  IBM Rational Test RealTime
#  (c) Copyright IBM Corp. 2003-2014 All Rights Reserved.
#
#  US Governement Users Restricted Rights - Use, duplication or
#  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
#################################################################################

##########################################################################
#                                                                        # #
# Rational Test RealTime                                                 #   #
#                                                                        #######
#                      -*-  Preprocessing tools -*-                            #
#                                                                              #                                                                                                      #
################################################################################
#-FEOPT list=foo.txt  can be used to debug preprocessing way
#
die "Environment variable TESTRTDIR not set.\n\n" if(!defined($ENV{'TESTRTDIR'})); # NO TRANSLATION
$TESTRTDIR="$ENV{'TESTRTDIR'}";
$SCRIPTDIR="$TESTRTDIR/lib/scripts/";
use File::Copy;

unless(@ARGV){
	print "usage: perllauncher cpp <srcFile> [-I<includePath>] [-D<macro>] [-o <outFile>] [-FEOPT list=<analyseFile>]\n";
	print "\n";
	return 0;
}
die "Environment variable ATLTGT must be set.\n" if(!defined($ENV{'ATLTGT'})); # NO TRANSLATION
require $SCRIPTDIR."Fcts.pl";

my $Command;
$INIFILE="tpcpp.ini";
my $hppFile="atl.hpp";
my $outopt=0;
foreach (@ARGV){
	if(/\.c$/){
		$out=$_.'.i';
		$lang="C";
		$INIFILE="tp.ini";
		$hppFile="atus_c.def";
	} elsif(/\.(C|cpp|cc)$/){
		$out=$_.'.i';
	} elsif(/^-o$/){
		$outopt=1;
	}
}
DecodeIniFile();


$Command="atostart4";
$Command="atostart" if(($ENV{USE_ATTOLCCP} eq "1") || ($Ini{USE_ATTOLCCP} eq "1"));
$Command .= " -opp atl.opp -hpp $hppFile";
$Command .= " ".join(" ",@ARGV) if(@ARGV);
$Command .= " -no_otd -no_otc -E";
$Command .= " -o \"$out\"" unless($outopt);
print "generating $out\n" unless($outopt);

my $status= SystemP($Command);
print "exec status $status\n";
1;