#################################################################################
#
#  Licensed Materials - Property of IBM
#  Restricted Material of IBM
#  IBM Rational Test RealTime
#  (c) Copyright IBM Corp. 2005-2007 All Rights Reserved.
#
#  US Governement Users Restricted Rights - Use, duplication or
#  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
#################################################################################

##########################################################################
#                                                                        # #
# Rational Test RealTime                                                 #   #
#                                                                        #######
#                 -*-  metric Analysis for C & C++ -*-                         #
#                                                                              #
#                                                                              #
################################################################################
#$Id: metricC.pl,v 1.8.4.2 2010/10/07 12:46:36 rfrance Exp $
################################################################################
# shall not access to Tools.pl to be used in attolcc

sub metricsC
{
	my $lang   = shift;
	my $src    = shift;
	my $logfile= shift;
	my $metdir = shift;
	my $Command;
	my $hppFile="atl.hpp";

	if ($lang eq "C")
	{
	    if($Ini{USE_STARTMETRIC})
	    {
		my $binn=''; $binn='.bin' if($^O=~/win32/i);
		$Command = "attolstartC$binn \"$src\" -STD_DEFINE=\"$TARGETDIR".$PATH_SEPARATOR."ana".$PATH_SEPARATOR."atus_c.def\"";
		if(@COMPLETE_INCLUDE_DIR_LIST){
			my $opt=" -incl=\"".join("\",\"",@COMPLETE_INCLUDE_DIR_LIST)."\"" ;
			$opt=~s,\\,/,g;
			$Command.=$opt ;
		}
		$Command.=" -define=\"".join("\",\"",@GENERATION_CONDITION)."\"" if(@GENERATION_CONDITION);
		$Command.=" -restrict_dir_metrics=\"".join("\",\"",@MET_RESTRICT_DIR)."\"" if(@MET_RESTRICT_DIR);
		$Command .= " -METRICS";
		$Command .= "=\"$metdir\"" unless ($MET_IN_SOURCE_DIR);
		$Command .= " -studio_log=\"$logfile\"" if($logfile ne '');
	    } elsif(($ENV{USE_ATTOLCC1} eq "1") || ($Ini{USE_ATTOLCC1} eq "1")) {
	      ## preprocessing
		my ($srcdir, $srcname, $srcext) = SplitFileName( $src );
		my $srcfile = $srcname.'.'.$srcext;
		my $prepro_file = "$INTDIR".$PATH_SEPARATOR."$srcname.i";
		print &PerlTranslate("Source.pl", "%1: Preprocessing...\n", "%1 is the file to be preprocessed", $srcfile);
		$status=atl_cpp ($language, $src, $prepro_file, $CPPFLAGS.' '.$PPFLAGS,
			       \@GENERATION_CONDITION, \@COMPLETE_INCLUDE_DIR_LIST );
		EndStep($status);
		#return $status if ($status);
		open ( LOG, ">>$LOGFILENAME" ) or die &PerlTranslate("Source.pl", "Cannot open log file: %1\n", "%1 is the reason given by the Operating System", $!);
		print  LOG "DUM $prepro_file\n";
		close( LOG );
		$Command = "metcc1 \"$prepro_file\" ";
		$Command.=" -restrict_metrics=\"".join("\",\"",@MET_RESTRICT_DIR)."\"" if(@MET_RESTRICT_DIR);
		$Command .= " -METRICS";
		$Command .= "=\"$metdir\"" unless ($MET_IN_SOURCE_DIR);
		$Command .= " -studio_log=\"$logfile\"" if($logfile ne '');
	    } else {
		$hppFile="atus_c.def";
	    }
		# Suppress old features
		delete $ENV{'ATTOLLAN'} ;
		delete $ENV{'ATTOLCINC'} ;
		delete $ENV{'ATTOLTMPK'} ;
		delete $ENV{'ATTOLCPPINC'} ;
		delete $ENV{'ATW_NO_USR_INCLUDE'} ;

		# Let's environment for attolstart
		$ENV{'ATTOLHOME'} = $ATTOLHOME;
		$ENV{'ATUDIR'} = $ATTOLHOME . $PATH_SEPARATOR."lib";
		$ENV{'ATUTGT'} = "$TARGETDIR";
	}
	unless($Command)
	{
		$Command="atostart4";
		$Command="atostart" if(($ENV{USE_ATTOLCCP} eq "1") || ($Ini{USE_ATTOLCCP} eq "1"));
		$Command .=  " \"$src\" -opp atl.opp -hpp $hppFile";
		if(@COMPLETE_INCLUDE_DIR_LIST){
			my $opt=" -I\"".join("\" -I\"",@COMPLETE_INCLUDE_DIR_LIST)."\"";
			$opt=~s,\\,\/,g;

			foreach(split(/,/,$Ini{STD_INCLUDE})){
				s,\\,\/,g;
				print $_," is system include\n" if($opt=~s! -I\"\Q$_\E[^\"]*\"!!g);
				if(s/^\w\://){
					print $_," is system include\n" if($opt=~s! -I\"\Q$_\E[^\"]*\"!!g);
				}
			}
			$Command.=$opt ;
		}
		$Command.=" \"-D".join("\" \"-D",@GENERATION_CONDITION)."\"" if(@GENERATION_CONDITION);
		foreach $dir (@MET_RESTRICT_DIR)
		{
			$Command .= " -restrict_dir_metrics \"$dir\"";
		}

		if($MET_IN_SOURCE_DIR)
		{
			$Command .= " -metrics_in_source";
		} else {
			$Command .= " -metrics \"$metdir\"";
		}
		$Command .= " -one_level_metrics" if ($MET_ONE_LEVEL);
		$Command .= " -studio_log \"$logfile\"";
	}

	$Command.=" ".$OPTIONS;

	$Command .= $MET_OPTIONS;
	$Command .= " ".$Ini{'METRIC_OPT'} if($Ini{'METRIC_OPT'});
	my $status;
	if($Ini{'ATTOLSTART'}) {
		print "ATTOLSTART specified as:$LP_TARGETDIR/cmd/$Ini{'ATTOLSTART'}\n";
		print "sub attolStart() executed with $Command\n";
		require "$TARGETDIR/cmd/$Ini{'ATTOLSTART'}";
		$status = attolStart($Command,$lang,$src);
	}
	else
	{
		$status = SystemP($BINPATH.$Command);
	}
	if ($status && ($status!=3))
	{
		print &PerlTranslate("metricC.pl", "Static Metrics Generation failed. Status $status\n");
	}

	return $status;
}

sub metricLink {
my %CALLS=();
	foreach my $m (@MET){
		if(open(IN,$m)){
			my ($File, $func, $funcLine, $funcClass, $callfunc, $callClass);
			while(<IN>){
				if(/<FILE\s/){
					if(/Name=\"([^\"]+)\"/){$File=$1;} 
				}
				elsif(/<(METHOD|FUNCTION)\s/){
					if(/Name=\"([^\"]+)\"/){$func=$1;} 
					if(/Line=\"([^\"]+)\"/){$funcLine=$1;} 
					if(/Class=\"([^\"]+)\"/){$funcClass=$1.':';} 
				}
				elsif(/<CALL\s/){
					if(/Name=\"([^\"]+)\"/){$callfunc=$1;} 
					if(/Class=\"([^\"]+)\"/){$callClass=$1.':';} 
					$CALLS{$callClass.$callfunc}++;
#					print "$callClass.$callfunc called from $File:$funcLine $funcClass$func\n"; 
				}

			}
			close IN;
		} else {
			print &PerlTranslate("metricC.pl", "Static Metrics $m not found.\n");
		}
	}
	foreach my $m (@MET){
		if(open(IN,$m)){
		    open(OU,">$m.txt");
			my ($File, $func, $funcLine, $funcClass, $callfunc, $callClass);
			while(<IN>){
				print OU;
				if(/<(METHOD|FUNCTION)\s/){
					if(/Name=\"([^\"]+)\"/){$func=$1;} 
					if(/Line=\"([^\"]+)\"/){$funcLine=$1;} 
					if(/Class=\"([^\"]+)\"/){$funcClass=$1.':';} 
				}
				elsif(/<METRIC\s+Key=\"EXTCOMPCALL\"/){
					if($CALLS{$funcClass.$func}>0){print OU "<METRIC Key=\"FAN_IN\" Value=\"$CALLS{$funcClass.$func}\"/>\n";} 
				}	
			}
			close OU;
			close IN;
			rename("$m.txt",$m);
		}
	}
	
}
1;
