##########################################################################
#                                                                        # #
# One Test Embedded                                                      #   #
#                                                                        #######
#             -*- Monitor host & runtime tables generation -*-                 #
#                                                                              #
#           v2 manage bitFields in accordance with new attolcc4                                                                   #
################################################################################

# To do output in chronological order when stderr and stdout are both used
use FileHandle ;
use File::Spec;
BEGIN {
  if ($^O eq "MSWin32") {
   use File::DosGlob 'glob';
 }
}
STDOUT->autoflush(1);
STDERR->autoflush(1);

$SCRIPTDIR="$ENV{'TESTRTDIR'}/lib/scripts/";
require $SCRIPTDIR . "Fcts.pl"; 
my $atk_float=-16;
my $atk_double=-17;            
my $atk_long_double=-18;
my $atk_string=-19;
my $atk_float_used=0;
my $atk_double_used=0;
my $atk_long_double_used=0;
my $atk_string_used=0;
my $atk_bitfields_used=0;

sub genMonitorTable
{
my $tsfList=shift;
my $idxF=0;
my $nbTypeTable=0;
my $nbTypeTableTmp=0;
my $MNT_MAX_DIM=0;
my @srcFilePaths;
my $MTTbuffer='';
my $monitorFile=(($NAME ne '')?$NAME:"monitortable").'.MNT';
my $tmptypefile="$INTDIR/masterType.tmp";
my $tmpvarfile="$INTDIR/masterVar.tmp";
my $mastertable="$INTDIR/masterTable.h";
open(MST,">$mastertable");#file included in the TP lib
open(MTT,">$tmptypefile");
open(MVT,">$tmpvarfile");
open(UIF,">$monitorFile");
print MST "/* this Master Table file is generated by the monitor.pl. Do not edit */\n\n" ;
print MVT "VARADDRESSTABLE()\n" ;
print MTT "VARSTRUCSIZETABLE()\n" ;
my $NbTSF=scalar(@$tsfList);
foreach my $f (@$tsfList){
my %sizeType;
	if(open(TSF,$f)){
		my $ln=0;
		my $valid=1;
		my $bitFieldCodeType;
		my $monit=0;
		my $idxT=0;
		my $idxV=0;
		my $src='';
		$NbTSF--;
	   while(<TSF>) {
	      $ln++;
	      if($valid && /^VG\s+(\d+)\s+(\d+)\s+(.+)$/) { 
			my $codeType=$2*-1;#basic types are negative
			my $varName=$3; 
			$idxV=$1;
			my $static=($varName=~s/static\s*$//);
			if($codeType == 0) {# list of struct types
			    $varName=~s/\s+$//;
				$sizeType{$varName}=$idxV;
				$idxT=$idxV+1;#print "type $varName=$idxV\n";
			} else  {
				unless(%sizeType || ($NbTSF<=0)) { push(@$tsfList,$f); last; } #remetre les liste sans type en fin de liste pour optimiser
				unless($monit){
					print "variable to monitor found in $f\n" ;
					print UIF "SC $idxF $src\n";
				}
				$monit++;
				my $NbDim=0;
				my $extra='';
				my $sizeList='';
				my $multiplierList='';
				my $rangeList='';
				#	print "#$ln >$_";
				#recover type for array
				while($varName=~m/^((.+)\[\d+,([\@\w][^\]]*)\])/){
					my $name=$1;
					my $base=$2;
					my $tcId=$3;
					my $tc;
					if($tcId eq '@'){
						$tcId=$name;
						$tcId=~s/\[[^\]]*\]/[0]/g;
					}
					$tc=$sizeType{$tcId};
					unless( defined $sizeType{$tcId}){
						$tc=-1;
						print "#>>Error Type not found \$sizeType{$tcId}=$sizeType{$tcId}\n" 
					}
					$varName=~s/^\Q$base\E\[(\d+),[^\]]+\]/$base\[$1\*1,$tc\]/;
					#print "::$varName \n";
				}
				#convert Array of basic type
				$varName=~s/\[(\d+)\]([^\[])/[$1\*1,$codeType]$2/;
				#print "::$varName \n";
				#spread array type and range on each dim
				while($varName=~s/\[(\d+)\]\[(\d+)(\*[^,]+)?,([^\]]+)\]/[$1*$2$3,$4][$2$3,$4]/) {} #print ":::$varName\n";};
				#remove range and put it on rangeList for each dim
				while($varName=~s/\[(\d+)\*/[\*/){$rangeList.=",$1"; };
				#simplify multiplier for each dim
				while($varName=~m/\[\*?(\d+)\*(\d+)/){ my $res=$1*$2; $varName=~s/\[\*?\d+\*\d+/[$res/;}
				#print "::::$varName \n";
				#move multipliers and types to lists
				while($varName=~s/\[\*?(\d+),([^\]]+)\]/[]/){
					$NbDim++;
					$multiplierList.=",$1";
					$sizeList.=",$2";
				}
				$MNT_MAX_DIM=$NbDim if($NbDim>$MNT_MAX_DIM);
				#change codeType for bitField
				if($varName=~s/,(\@|(\w[^\],\.]*))\s*$//){
					(my $tcId=$1)=~s/\s+$//;
					if($tcId eq '@'){ #unnamed type -> use sizeof(var)
						$tcId=$varName;
						$tcId=~s/\[\]/[0]/g;
					}
					#print "::T:\$sizeType{$tcId}=$sizeType{$tcId}\n";
					$codeType=$sizeType{$tcId};
					unless( defined $sizeType{$tcId}){
						$codeType=-1;
						print "#>>Error Type not found \$sizeType{$tcId}=$sizeType{$tcId}\n" 
					}
					$bitFieldCodeType=$codeType;
				}
				#code for each found bitfield name
				#$1 is Byte offset, $2 bit offset, $3 length in bits, $4
				#$1 is field->offset (in bytes),$2 field->offset_bit_remainder,$3 field->bit_size,$4 field->alignment
				if($varName=~s/\+(\d+)b(\d+)l(\d+)a(\d+)\s*$//){ $extra="{$1,$2,$3,$4,$codeType}";$codeType=$bitFieldCodeType;$atk_bitfields_used=1;}
				
				#change var name for static variable in order to avoid double names
				$varName=$src.':'.$varName if($static);
				#remove end space (added by instrumentor) required by previous regexp
				$varName=~s/\s+$//;
				print UIF "VG $varName$extra,$idxF,$idxV,$codeType,$NbDim$sizeList$multiplierList$rangeList\n";
				if($codeType <=$atk_float) {
					if($codeType == $atk_float) {$atk_float_used=1;}
					elsif($codeType == $atk_double) {$atk_double_used=1;}
					elsif($codeType == $atk_long_double) {$atk_long_double_used=1;}
					elsif($codeType == $atk_string) {$atk_string_used=1;}
				}
			}
		  } elsif($valid && /^ID\s+(\d+)\s+(\d+)\s*$/) {
			my $key=$1;
			my $cks=$2;
			if($monit){
				$idxV++;
				print MST "EXTERN_MONITOR_GLOBALS($idxF,$key,$cks,$idxV,$src)\n";
				print MVT "MONITOR_GLOBALS($idxF,$key,$cks,$idxV,$src)\n";
				if($idxT){
					print MST "EXTERN_MONITOR_TYPES($idxF,$key,$cks,$idxT)\n" ;
					print MTT "$MTTbuffer MONITOR_TYPES($idxF,$key,$cks,$idxT)\n" ;
					$MTTbuffer='';
					$nbTypeTable+=1+$nbTypeTableTmp;
					$nbTypeTableTmp=0;
				} else {
					$MTTbuffer.= " MONITOR_NO_TYPES($idxF)\n";
					$nbTypeTableTmp++;
				}
				$idxF++;
			}
		  } elsif(/^IN "\w+" \d+ "([^\"]+)"\s*$/) {
			  $src=$1;
		  } elsif(/^SO "([^\"]+)"/) {
			  my $path=$1;
			  if(grep(/\Q$path\E/,@srcFilePaths)) {
				$valid=0;
				print "found multiple TSF block for $path only first one is taken into account\n";
			  } else {
				$srcFilePaths[$idxF]=$1;
				$valid=1;
			  }
		  }
	   } close TSF;
	   
	}
  }
  print MVT "VARADDRESSTABLE_END($idxF)\n\n";
  print MTT "VARSTRUCSIZETABLE_END($nbTypeTable)\n";
  close MTT;
  close MVT;
  open(MVT,$tmpvarfile);
  while(<MVT>) { print MST; }
  close MVT;
  open(MTT,$tmptypefile);
  while(<MTT>) { print MST; }
  close MTT;
  print MST "\n#define MNT_MAX_DIM $MNT_MAX_DIM\n";
  print MST "\n#define MNTUSE_FLOAT $atk_float_used\n";
  print MST "\n#define MNTUSE_DOUBLE ",$atk_double_used+$atk_long_double_used,"\n";
  print MST "\n#define MNTUSE_STRING $atk_string_used\n";
  print MST "\n#define NEEDS_MNT_BITFIELDS\n" if($atk_bitfields_used);
  print MST "\n#define VARADDRESSTABLE_SIZE $idxF\n";
  print MST "\n#define VARSTRUCSIZETABLE_SIZE $nbTypeTable\n";
  close MST;  
  close UIF;
  unlink($tmptypefile,$tmpvarfile);
  RegisterGenFiles("MNT $monitorFile","DUM $mastertable") if($LOGFILENAME ne '');
  return $idxF;
}

sub genMonitor_help
{
my ($dirlauncher,$launcherBase,$extl)=SplitFileName($0);
    print STDERR "#?$SMALL_PRODUCT_NAME-I-".uc($launcherBase).", Usage:  $launcherBase *.tsf\n";
}

#executed when launched in command line
sub genMonitor
{
ReadProductName();
$INTDIR="." unless($INTDIR);
print STDERR "#?$SMALL_PRODUCT_NAME-I-monitor\n";
 if(@ARGV) {
	if($ARGV[0]=~m/-help/i) {
		genMonitor_help();
		return(0);
	} 
 } else {
	genMonitor_help();
	return(0);
 }

 my @TSFFILES;
 foreach my $f (@ARGV)
 {
  if(-f $f && $f=~m/.tsf$/i){
	push(@TSFFILES,$f);
  } elsif($f=~m/\*/) {
		my @files = glob $f;
		push(@ARGV,@files );
  } else {
    print "Unused arg: $f\n" if($f ne '');
  }
 }
  
 my $out=genMonitorTable(\@TSFFILES);
 unless($out) { print "No variable to monitor found in TSF files\n"; }
 else {print "Variables found in $out files\n"; }
 return 0;
}

exit(genMonitor()) if($0 =~m/monitor\.pl$/);
1;
